#include "clip.h"

/////////////////////////////////////////////////////////////////////////////
#define APPNAME	"C17WIN"
#define WIDTH	(72)
#define HEIGHT	(32)
#define SCALE	4
unsigned char xbuff[HEIGHT][WIDTH / 8];
int P0 = -1;
int P2 = -1;
/////////////////////////////////////////////////////////////////////////////
BITMAPINFO* pBMI;
HWND MainWnd;
LRESULT CALLBACK
WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg) {
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	case WM_CHAR:
		if(wParam == 'q') {
			DestroyWindow(hWnd);
			return 0;
		}
		return 0;
	case WM_KEYDOWN:
		switch(wParam) {
		case '2':
			P0 &= ~0x40;
			break;
		case '3':
			P0 &= ~0x80;
			break;
		}
		break;
	case WM_KEYUP:
		switch(wParam) {
		case '2':
			P0 |= 0x40;
			break;
		case '3':
			P0 |= 0x80;
			break;
		}
		break;
	}
	return DefWindowProc(hWnd, msg, wParam, lParam);
}
int
DoMsg()
{
	MSG msg;
	while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
		if(msg.message == WM_QUIT) {
			return 0;
		}
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return 1;
}
void
InitUI()
{
	BITMAPINFOHEADER* bi;
	RGBQUAD* rgb;
	HINSTANCE hInst;
	WNDCLASS wc;
	RECT rcWin;
	RECT rcCli;
	int ncW;
	int ncH;

	pBMI = (BITMAPINFO*)calloc(sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * 2, 1);
	bi = &pBMI->bmiHeader;
	rgb = &pBMI->bmiColors[0];
	bi->biSize = sizeof(BITMAPINFOHEADER);
	bi->biWidth = WIDTH;
	bi->biHeight = -HEIGHT;
	bi->biPlanes = 1;
	bi->biBitCount = 1;
	rgb[0].rgbRed = rgb[0].rgbGreen = rgb[0].rgbBlue = -1;
	rgb[1].rgbRed = rgb[1].rgbGreen = rgb[1].rgbBlue = 0;

	hInst = GetModuleHandle(NULL);
	//
	memset(&wc, 0, sizeof wc);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WndProc;
	wc.hInstance = hInst;
	wc.hCursor = LoadCursor(NULL, IDC_CROSS);
	wc.lpszClassName = APPNAME;
	RegisterClass(&wc);
	//
	MainWnd = CreateWindow(APPNAME, APPNAME,
		WS_OVERLAPPED,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
		NULL, NULL, hInst, NULL);
	//
	GetWindowRect(MainWnd, &rcWin);
	GetClientRect(MainWnd, &rcCli);
	ncW = (rcWin.right - rcWin.left) - (rcCli.right - rcCli.left);
	ncH = (rcWin.bottom - rcWin.top) - (rcCli.bottom - rcCli.top);
	MoveWindow(MainWnd, 0, 0,
		ncW + bi->biWidth  * SCALE,
		ncH - bi->biHeight * SCALE, 0);
	//
	ShowWindow(MainWnd, SW_SHOW);
	UpdateWindow(MainWnd);
}

/****************************************************************************
 *	
 ****************************************************************************/

/* 0x008000 */
static const unsigned char SimpleGDBServer[] = {
#include "SimpleGDBServer.h"
};
/* 0x00C000 */
static const unsigned char CQ_StartSample[] = {
#include "CQ_StartSample.h"
};
/* 0x00C07C */
static const unsigned char MagicCode[] = {0x00,0x00,0x17,0xEC};

int
main(int argc, char* argv[])
{
	int t0;
	int t1;
	HDC hDC;
	RECT rc;

	InitUI();

	s1c17_flash_load(0x008000, SimpleGDBServer, sizeof SimpleGDBServer);
	s1c17_flash_load(0x00C000, CQ_StartSample, sizeof CQ_StartSample);
	s1c17_flash_load(0x00C07C, MagicCode, sizeof MagicCode);	//t[[ĥ
	s1c17_init();
	s1c17_port_set(3, 0);	//t[[ĥ

	t0 = GetTickCount();
	hDC = GetDC(MainWnd);
	GetClientRect(MainWnd, &rc);
	for(;;) {
		if(!DoMsg()) {
			break;
		}

		//-----------------------------------------------------------
		s1c17_port_set(0, P0);
		s1c17_exec(8000000 / 60);
		s1c17_lcd_image(xbuff);
		P2 = s1c17_port_get(2);
		//-----------------------------------------------------------

		{	/* PIECE_BMPWindows BMPϊ */
			unsigned char tmpbuf[HEIGHT][((WIDTH / 8) + 3) & ~3];
			int i;
			for(i = 0; i < HEIGHT; i++) {
				memcpy(tmpbuf[i], xbuff[i], sizeof xbuff[0]);
			}
			StretchDIBits(hDC,
				rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top,
				0, 0, pBMI->bmiHeader.biWidth, -pBMI->bmiHeader.biHeight,
				tmpbuf,
				pBMI,
				DIB_RGB_COLORS,
				SRCCOPY);
		}

		{
			static int old_P2;
			if(old_P2 != P2) {
				old_P2 = P2;
				if(P2 & 0x80) {
					SetWindowText(MainWnd, APPNAME);
				} else {
					SetWindowText(MainWnd, APPNAME "");
				}
			}
		}

		for(;;) {
			t1 = GetTickCount();
			if(t1 - t0 >= 1000 / 60) break;
			Sleep(0);
		}
		t0 = GetTickCount();
	}
	ReleaseDC(MainWnd, hDC);
}

