/*	
 *	clipc17.c
 *
 *	P/ECE EPSON S1C17702 Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2010 Naoyuki Sawa
 *
 *	* Fri Dec 25 00:36:52 JST 2009 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "clip.h"

/* S1C17_TRACEV{`ƁAg[Xo͂s܂B */
//#define S1C17_TRACE

/****************************************************************************
 *	
 ****************************************************************************/

/* vZbT */
//#define S1C17_MODE_USER	0	/* [U[[h */
#define S1C17_MODE_DEBUG	1	/* fobO[h */
#define S1C17_MODE_HALT		2	/* HALT[h */
#define S1C17_MODE_SLEEP	3	/* SLEEP[h */
static int s1c17_mode;

/* G~[^TCNJEgp */
static int s1c17_cycle;

/****************************************************************************
 *	
 ****************************************************************************/

/* CPU */
static void s1c17_cpu_init();
static void s1c17_cpu_exec();
/* RAMGA */
static void s1c17_iram_init();
static int s1c17_iram_read(int size, int ofs);
static void s1c17_iram_write(int size, int ofs, int data);
/* ӉHGA1 */
/* vXP[ */
//static void s1c17_psc_init();
//static int s1c17_psc_read(int size, int ofs);
//static void s1c17_psc_write(int size, int ofs, int data);
/* UART */
//static void s1c17_uart_init();
//static int s1c17_uart_read(int size, int ofs);
//static void s1c17_uart_write(int size, int ofs, int data);
/* 8rbg^C} */
//static void s1c17_t8f_init();
//static int s1c17_t8f_0_read(int size, int ofs);
//static void s1c17_t8f_0_write(int size, int ofs, int data);
//static int s1c17_t8f_1_read(int size, int ofs);
//static void s1c17_t8f_1_write(int size, int ofs, int data);
/* 16rbg^C} */
static void s1c17_t16_init();
static int s1c17_t16_0_read(int size, int ofs);
static void s1c17_t16_0_write(int size, int ofs, int data);
static int s1c17_t16_1_read(int size, int ofs);
static void s1c17_t16_1_write(int size, int ofs, int data);
static int s1c17_t16_2_read(int size, int ofs);
static void s1c17_t16_2_write(int size, int ofs, int data);
static void s1c17_t16_exec();
/* 荞݃Rg[ */
static void s1c17_itc_init();
static int s1c17_itc_read(int size, int ofs);
static void s1c17_itc_write(int size, int ofs, int data);
static void s1c17_itc_irq(int no);
/* SPI */
//static void s1c17_spi_init();
//static int s1c17_spi_read(int size, int ofs);
//static void s1c17_spi_write(int size, int ofs, int data);
/* I2C */
//static void s1c17_i2c_init();
//static int s1c17_i2c_read(int size, int ofs);
//static void s1c17_i2c_write(int size, int ofs, int data);
/* ӉHGA2 */
/* v^C} */
//static void s1c17_ct_init();
//static int s1c17_ct_read(int size, int ofs);
//static void s1c17_ct_write(int size, int ofs, int data);
/* XgbvEHb`^C} */
//static void s1c17_swt_init();
//static int s1c17_swt_read(int size, int ofs);
//static void s1c17_swt_write(int size, int ofs, int data);
/* EHb`hbO^C} */
//static void s1c17_wdt_init();
//static int s1c17_wdt_read(int size, int ofs);
//static void s1c17_wdt_write(int size, int ofs, int data);
/* UH */
//static void s1c17_osc_init();
//static int s1c17_osc_read(int size, int ofs);
//static void s1c17_osc_write(int size, int ofs, int data);
/* NbNWFl[^ */
//static void s1c17_clg_init();
//static int s1c17_clg_read(int size, int ofs);
//static void s1c17_clg_write(int size, int ofs, int data);
/* LCDhCo */
//static void s1c17_lcd_init();
//static int s1c17_lcd_read(int size, int ofs);
//static void s1c17_lcd_write(int size, int ofs, int data);
/* 8rbgOSC1^C} */
//static void s1c17_t8osc1_init();
//static int s1c17_t8osc1_read(int size, int ofs);
//static void s1c17_t8osc1_write(int size, int ofs, int data);
/* SVDH */
//static void s1c17_svd_init();
//static int s1c17_svd_read(int size, int ofs);
//static void s1c17_svd_write(int size, int ofs, int data);
/* dH */
//static void s1c17_vd1_init();
//static int s1c17_vd1_read(int size, int ofs);
//static void s1c17_vd1_write(int size, int ofs, int data);
/* P|[g */
static void s1c17_p_init();
static int s1c17_p_read(int size, int ofs);
static void s1c17_p_write(int size, int ofs, int data);
static void s1c17_p_exec();
/* |[gMUX */
//static void s1c17_pmux_init();
//static int s1c17_pmux_read(int size, int ofs);
//static void s1c17_pmux_write(int size, int ofs, int data);
/* PWM&Lv`^C} */
//static void s1c17_t16e_init();
//static int s1c17_t16e_0_read(int size, int ofs);
//static void s1c17_t16e_0_write(int size, int ofs, int data);
//static int s1c17_t16e_1_read(int size, int ofs);
//static void s1c17_t16e_1_write(int size, int ofs, int data);
/* MISCWX^ */
static void s1c17_misc_init();
static int s1c17_misc_read(int size, int ofs);
static void s1c17_misc_write(int size, int ofs, int data);
/* [gRg[ */
//static void s1c17_remc_init();
//static int s1c17_remc_read(int size, int ofs);
//static void s1c17_remc_write(int size, int ofs, int data);
/* FlashGA */
static void s1c17_flash_init();
static int s1c17_flash_read(int size, int ofs);
static void s1c17_flash_write(int size, int ofs, int data);
/* \RAMGA */
static void s1c17_sram_init();
static int s1c17_sram_read(int size, int ofs);
static void s1c17_sram_write(int size, int ofs, int data);
/* RAI/O\GA */
/* I`bvfobK */
static void s1c17_dbg_init();
static int s1c17_dbg_read(int size, int ofs);
static void s1c17_dbg_write(int size, int ofs, int data);

/****************************************************************************
 *	}bvAoX
 ****************************************************************************/

typedef struct _s1c17_device {
	int top;					/* JnAhX (-1 = I[) */
	int end;					/* IAhX */
	int size;					/* foCXTCY (1 = 8rbg, 2 = 16rbg, 4 = 32rbg) */
	int (*read)(int size, int ofs);			/* ǂݏonh (NULL = ) */
	void (*write)(int size, int ofs, int data);	/* ݃nh (NULL = ) */
} s1c17_device;
static s1c17_device s1c17_device_tbl[] = {
	/* RAMGA */
	{0x000000,0x002FFF,4,s1c17_iram_read  ,s1c17_iram_write  },
	/* ӉHGA1 */
//	{0x004000,0x00401F},						//reserved
//	{0x004020,0x00403F,1,s1c17_psc_read   ,s1c17_psc_write   },	//vXP[
//	{0x004040,0x0040FF},						//reserved
//	{0x004100,0x00413F,1,s1c17_uart_read  ,s1c17_uart_write  },	//UART
//	{0x004140,0x0041FF},						//reserved
//	{0x004200,0x00421F,2,s1c17_t8f_0_read ,s1c17_t8f_0_write },	//8rbg^C} Ch.0
	{0x004220,0x00423F,2,s1c17_t16_0_read ,s1c17_t16_0_write },	//16rbg^C} Ch.0
	{0x004240,0x00425F,2,s1c17_t16_1_read ,s1c17_t16_1_write },	//16rbg^C} Ch.1
	{0x004260,0x00427F,2,s1c17_t16_2_read ,s1c17_t16_2_write },	//16rbg^C} Ch.2
//	{0x004280,0x00429F,2,s1c17_t8f_1_read ,s1c17_t8f_1_write },	//8rbg^C} Ch.1
//	{0x0042A0,0x0042FF},						//reserved
	{0x004300,0x00431F,2,s1c17_itc_read   ,s1c17_itc_write   },	//荞݃Rg[
//	{0x004320,0x00433F,2,s1c17_spi_read   ,s1c17_spi_write   },	//SPI
//	{0x004340,0x00435F,2,s1c17_i2c_read   ,s1c17_i2c_write   },	//I2C
//	{0x004360,0x0043FF},						//reserved
	/* ӉHGA2 */
//	{0x005000,0x00501F,1,s1c17_ct_read    ,s1c17_ct_write    },	//v^C}
//	{0x005020,0x00503F,1,s1c17_swt_read   ,s1c17_swt_write   },	//XgbvEHb`^C}
//	{0x005040,0x00505F,1,s1c17_wdt_read   ,s1c17_wdt_write   },	//EHb`hbO^C}
//	{0x005060,0x00507F,1,s1c17_osc_read   ,s1c17_osc_write   },	//UH
//	{0x005080,0x00509F,1,s1c17_clg_read   ,s1c17_clg_write   },	//NbNWFl[^
//	{0x0050A0,0x0050BF,1,s1c17_lcd_read   ,s1c17_lcd_write   },	//LCDhCo
//	{0x0050C0,0x0050DF,1,s1c17_t8osc1_read,s1c17_t8osc1_write},	//8rbgOSC1^C}
//	{0x0050E0,0x0050FF},						//reserved
//	{0x005100,0x00511F,1,s1c17_svd_read   ,s1c17_svd_write   },	//SVDH
//	{0x005120,0x00513F,1,s1c17_vd1_read   ,s1c17_vd1_write   },	//dH
//	{0x005140,0x0051FF},						//reserved
	{0x005200,0x00527F,1,s1c17_p_read     ,s1c17_p_write     },	//P|[g
//	{0x005280,0x00529F},						//reserved
//	{0x0052A0,0x0052BF,1,s1c17_pmux_read  ,s1c17_pmux_write  },	//|[gMUX
//	{0x0052C0,0x0052FF},						//reserved
//	{0x005300,0x00531F,2,s1c17_t16e_0_read,s1c17_t16e_0_write},	//PWM&Lv`^C} Ch.0
	{0x005320,0x00533F,2,s1c17_misc_read  ,s1c17_misc_write  },	//MISCWX^
//	{0x005340,0x00535F,2,s1c17_remc_read  ,s1c17_remc_write  },	//[gRg[
//	{0x005360,0x00537F,2,s1c17_t16e_1_read,s1c17_t16e_1_write},	//PWM&Lv`^C} Ch.1
//	{0x005380,0x005FFF},						//reserved
	/* FlashGA */
	{0x008000,0x027FFF,2,s1c17_flash_read ,s1c17_flash_write },
	/* \RAMGA */
	{0x080000,0x08055F,1,s1c17_sram_read  ,s1c17_sram_write  },
	/* RAI/O\GA */
//	{0xFFFC00,0xFFFF7F},						//~jj^
	{0xFFFF80,0xFFFFFF,4,s1c17_dbg_read   ,s1c17_dbg_write   },	//I`bvfobK
{-1}}; /* I[ */

/* foCX */
static s1c17_device* s1c17_device_select(int size, int addr) {
	s1c17_device* device;
	/* sAhX */
	if(addr & (size - 1)) {
		DIE(); /* TODO:ʃrbg0Ƃăf[^]AAhXs荞݂𐶐 */
	}
	/* foCXe[u */
	device = s1c17_device_tbl;
	while(device->top != -1/*I[*/) {
		if((addr >= device->top) && (addr <= device->end)) {
			/*{{LRU*/
			if(device != s1c17_device_tbl) {
				s1c17_device tmp = device[0];
				do {
					device--;
					device[1] = device[0];
				} while(device != s1c17_device_tbl);
				device[0] = tmp;
			}
			/*}}LRU*/
			return device; /*  */
		}
		device++;
	}
	return NULL; /* Ȃ */
}
static int s1c17_bcu_read(int size, int addr) {
	int data = 0;
	s1c17_device* device = s1c17_device_select(size, addr);
	if(device && device->read) {
		int ofs = addr - device->top;
		/* CPUANZXTCYAfoCXTCYȉɕ */
		switch(device->size) {
		case 1: /* foCXTCY = 8rbg */
			switch(size) {
			case 1: /* CPUANZXTCY = 8rbg */
				data  = device->read(1, ofs);
				break;
			case 2: /* CPUANZXTCY = 16rbg */
				data  = device->read(1, ofs);       ofs += 1;
				data |= device->read(1, ofs) <<  8;
				break;
			default:/* CPUANZXTCY = 32rbg */
				data  = device->read(1, ofs);       ofs += 1;
				data |= device->read(1, ofs) <<  8; ofs += 1;
				data |= device->read(1, ofs) << 16; ofs += 1;
				data |= device->read(1, ofs) << 24;
				break;
			}
			break;
		case 2: /* foCXTCY = 16rbg */
			switch(size) {
			case 1: /* CPUANZXTCY = 8rbg */
				data  = device->read(1, ofs);
				break;
			case 2: /* CPUANZXTCY = 16rbg */
				data  = device->read(2, ofs);
				break;
			default:/* CPUANZXTCY = 32rbg */
				data  = device->read(2, ofs);       ofs += 2;
				data |= device->read(2, ofs) << 16;
				break;
			}
			break;
		default:/* foCXTCY = 32rbg */
			switch(size) {
			case 1: /* CPUANZXTCY = 8rbg */
				data  = device->read(1, ofs);
				break;
			case 2: /* CPUANZXTCY = 16rbg */
				data  = device->read(2, ofs);
				break;
			default:/* CPUANZXTCY = 32rbg */
				data  = device->read(4, ofs);
				break;
			}
			break;
		}
	}
	return data;
}
static void s1c17_bcu_write(int size, int addr, int data) {
	s1c17_device* device = s1c17_device_select(size, addr);
	if(device && device->write) {
		int ofs = addr - device->top;
		/* CPUANZXTCYAfoCXTCYȉɕ */
		switch(device->size) {
		case 1: /* foCXTCY = 8rbg */
			switch(size) {
			case 1: /* CPUANZXTCY = 8rbg */
				device->write(1, ofs, (unsigned char)data);
				break;
			case 2: /* CPUANZXTCY = 16rbg */
				device->write(1, ofs, (unsigned char)data); ofs += 1; data >>= 8;
				device->write(1, ofs, (unsigned char)data);
				break;
			default:/* CPUANZXTCY = 32rbg */
				device->write(1, ofs, (unsigned char)data); ofs += 1; data >>= 8;
				device->write(1, ofs, (unsigned char)data); ofs += 1; data >>= 8;
				device->write(1, ofs, (unsigned char)data); ofs += 1; data >>= 8;
				device->write(1, ofs, (unsigned char)data);
				break;
			}
			break;
		case 2: /* foCXTCY = 16rbg */
			switch(size) {
			case 1: /* CPUANZXTCY = 8rbg */
				device->write(1, ofs, (unsigned char)data);
				break;
			case 2: /* CPUANZXTCY = 16rbg */
				device->write(2, ofs, (unsigned short)data);
				break;
			default:/* CPUANZXTCY = 32rbg */
				device->write(2, ofs, (unsigned short)data); ofs += 2; data >>= 16;
				device->write(2, ofs, (unsigned short)data);
				break;
			}
			break;
		default:/* foCXTCY = 32rbg */
			switch(size) {
			case 1: /* CPUANZXTCY = 8rbg */
				device->write(1, ofs, (unsigned char)data);
				break;
			case 2: /* CPUANZXTCY = 16rbg */
				device->write(2, ofs, (unsigned short)data);
				break;
			default:/* CPUANZXTCY = 32rbg */
				device->write(4, ofs, data);
				break;
			}
			break;
		}
	}
}

/****************************************************************************
 *	CPU
 ****************************************************************************/

/* ߃e[u */
#define S1C17_OP(mask,code,fn,name) static void fn();
#include "s1c17/op.h"
#undef S1C17_OP
typedef struct _s1c17_op {
	unsigned short mask;	/* ߃R[h̃}XN */
	unsigned short code;	/* ̒lƈv */
	void (*fn)();		/* ̊֐Ăяo */
#ifdef S1C17_TRACE
	const char* name;	/* g[Xpj[jbN */
#endif /*S1C17_TRACE*/
} s1c17_op;
static s1c17_op s1c17_op_tbl[] = {
#ifdef S1C17_TRACE
#define S1C17_OP(mask,code,fn,name) {mask,code,fn,name},
#else /*S1C17_TRACE*/
#define S1C17_OP(mask,code,fn,name) {mask,code,fn},
#endif /*S1C17_TRACE*/
#include "s1c17/op.h"
#undef S1C17_OP
{0}}; /* I[ */

/* ߃R[h` */
typedef union _s1c17_code {
	struct {
		unsigned short imm13 :13;
		unsigned short       : 3;
	} x3_imm13;
	struct {
		         short sign10:10;
		unsigned short d     : 1;
		unsigned short       : 5;
	} x5_d_sign10;
	struct {
		unsigned short       : 2;
		unsigned short imm5  : 5;
		unsigned short imm3  : 3;
		unsigned short       : 6;
	} x6_imm3_imm5_x2;
	struct {
		unsigned short imm7  : 7;
		unsigned short rd    : 3;
		unsigned short       : 6;
	} x6_rd_imm7;
	struct {
		         short sign7 : 7;
		unsigned short rd    : 3;
		unsigned short       : 6;
	} x6_rd_sign7;
	struct {
		unsigned short rb    : 3;
		unsigned short       : 4;
		unsigned short rd    : 3;
		unsigned short       : 6;
	} x6_rd_x4_rb;
	struct {
		unsigned short rs    : 3;
		unsigned short       : 4;
		unsigned short rd    : 3;
		unsigned short       : 6;
	} x6_rd_x4_rs;
	struct {
		unsigned short       : 7;
		unsigned short rd    : 3;
		unsigned short       : 6;
	} x6_rd_x7;
	struct {
		unsigned short imm7  : 7;
		unsigned short rs    : 3;
		unsigned short       : 6;
	} x6_rs_imm7;
	struct {
		unsigned short rb    : 3;
		unsigned short       : 4;
		unsigned short rs    : 3;
		unsigned short       : 6;
	} x6_rs_x4_rb;
	struct {
		unsigned short       : 7;
		unsigned short rs    : 3;
		unsigned short       : 6;
	} x6_rs_x7;
	struct {
		unsigned short imm7  : 7;
		unsigned short d     : 1;
		unsigned short       : 8;
	} x8_d_imm7;
	struct {
		         short sign7 : 7;
		unsigned short d     : 1;
		unsigned short       : 8;
	} x8_d_sign7;
	struct {
		unsigned short rb    : 3;
		unsigned short       : 4;
		unsigned short d     : 1;
		unsigned short       : 8;
	} x8_d_x4_rb;
	struct {
		unsigned short       : 7;
		unsigned short d     : 1;
		unsigned short       : 8;
	} x8_d_x7;
	struct {
		unsigned short       : 2;
		unsigned short imm5  : 5;
		unsigned short       : 9;
	} x9_imm5_x2;
	struct {
		unsigned short imm7  : 7;
		unsigned short       : 9;
	} x9_imm7;
	struct {
		unsigned short rs    : 3;
		unsigned short       :13;
	} x13_rs;
	unsigned short x16;
} s1c17_code;

/* %psr` */
typedef struct _s1c17_psr {
	unsigned char n :1;	/* Negative */
	unsigned char z :1;	/* Zero */
	unsigned char v :1;	/* oVerflow */
	unsigned char c :1;	/* Carry */
	unsigned char ie:1;	/* Interrupt Enable */
	unsigned char il:1;	/* Interrupt Level */
} s1c17_psr;

/* RvZbT(揜Z) */
typedef struct _s1c17_coprocessor {
	unsigned char operating_mode;	/* 샂[h */
	unsigned char output_mode;	/* o̓[h */
	unsigned char overflow_flag;	/* I[o[t[tO */
	int arithmetic_result;		/* ZʃWX^ */
} s1c17_coprocessor;

/* CPURA */
typedef struct _S1C17_CPU {
	int r[8];			/* %r0 - %r7 (D[31:24] = 0) */
	int pc;				/* %pc (D[31:24] = 0, D[0] = 0) */
	int sp;				/* %sp (D[1:0] = 0) */
	s1c17_psr psr;			/* %psr */
	//
	s1c17_code code;		/* ݏ̖߃R[h */
	unsigned short ext1;		/* ŐVext (0 = ) */
	unsigned short ext2;		/* Oext (0 = ) */
	//
	s1c17_coprocessor coprocessor;	/* RvZbT */
} S1C17_CPU;
static S1C17_CPU s1c17_cpu;

/*--------------------------------------------------------------------------*/

static void s1c17_cpu_init() {
	memset(&s1c17_cpu, 0, sizeof s1c17_cpu);
	s1c17_cpu.pc = s1c17_bcu_read(4, s1c17_bcu_read(4, 0xFFFF80/*TTBR*/));
	s1c17_cpu.pc = (unsigned)(s1c17_cpu.pc << 8) >> 8;
	s1c17_cpu.pc &= ~1;
}
static void s1c17_cpu_exec() { /* 1ߎs */
	s1c17_op* op;

	/* ߃tFb` */
	s1c17_cpu.code.x16 = s1c17_bcu_read(2, s1c17_cpu.pc);

	/* %pci߂B
	 * S1C17́AS1C33ƈāA߂sO%pci݂܂B(Z80Ɠlł)
	 * %pcΕ򖽗߂ȂǂɂāÄႢɒӂĂB
	 */
	s1c17_cpu.pc += 2;
	s1c17_cpu.pc = (unsigned)(s1c17_cpu.pc << 8) >> 8;

	/* ߃e[u */
	op = s1c17_op_tbl;
	while(op->mask) {
		if((s1c17_cpu.code.x16 & op->mask) == op->code) {
			/*{{LRU*/
			if(op != s1c17_op_tbl) {
				s1c17_op tmp = op[0];
				do {
					op--;
					op[1] = op[0];
				} while(op != s1c17_op_tbl);
				op[0] = tmp;
			}
			/*}}LRU*/
#ifdef S1C17_TRACE
			printf("%06x %04x %s\n", s1c17_cpu.pc - 2, s1c17_cpu.code.x16, op->name);
#endif /*S1C17_TRACE*/
			/* ߎs */
			op->fn();
			return; /* ܂ */
		}
		op++;
	}

	/* sȖ */
#ifdef S1C17_TRACE
	printf("%06x %04x ?\n", s1c17_cpu.pc - 2, s1c17_cpu.code.x16);
#endif /*S1C17_TRACE*/
#ifdef DEBUG
	DIE();
#endif /*DEBUG*/
}

/*--------------------------------------------------------------------------*/
/* extg̋ʏ */

static int s1c17_0_imm13_imm24() {
	int x = 0;						/* 00000000 00000000 00000000 00000000 */
	if(s1c17_cpu.ext1) {
		x = s1c17_cpu.ext1 & 0x1FFF;			/* 00000000 00000000 000yyyyy yyyyyyyy */ 
		if(s1c17_cpu.ext2) {
			x |= s1c17_cpu.ext2 << 13;		/* 000????? zzzzzzzz zzzyyyyy yyyyyyyy */
			x = (unsigned)(x << 8) >> 8;		/* 00000000 zzzzzzzz zzzyyyyy yyyyyyyy */
		}
		s1c17_cpu.ext1 = s1c17_cpu.ext2 = 0;
	}
	return x;
}
static int s1c17_0_imm13_imm16() {
	return (unsigned short)s1c17_0_imm13_imm24();
}
static int s1c17_rb_rb_imm13_rb_imm24() {
	int rb = s1c17_cpu.code.x16 & 7;
	int x = s1c17_0_imm13_imm24() + s1c17_cpu.r[rb];
	return (unsigned)(x << 8) >> 8;
}
static int s1c17_sp_sp_imm13_sp_imm24() {
	int x = s1c17_0_imm13_imm24() + s1c17_cpu.sp;
	return (unsigned)(x << 8) >> 8;
}
static void s1c17_increment_rb_x_imm13_imm24(int x) {
	int rb = s1c17_cpu.code.x16 & 7;
	s1c17_cpu.r[rb] += s1c17_cpu.ext1 ? s1c17_0_imm13_imm24() : x;
	s1c17_cpu.r[rb] = (unsigned)(s1c17_cpu.r[rb] << 8) >> 8;
}
static void s1c17_decrement_rb_x_imm13_imm24(int x) {
	int rb = s1c17_cpu.code.x16 & 7;
	s1c17_cpu.r[rb] -= s1c17_cpu.ext1 ? s1c17_0_imm13_imm24() : x;
	s1c17_cpu.r[rb] = (unsigned)(s1c17_cpu.r[rb] << 8) >> 8;
}
static void s1c17_increment_sp_x_imm13_imm24(int x) {
	s1c17_cpu.sp += s1c17_cpu.ext1 ? s1c17_0_imm13_imm24() : x;
	s1c17_cpu.sp = (unsigned)(s1c17_cpu.sp << 8) >> 8;
	s1c17_cpu.sp &= ~3;
}
static void s1c17_decrement_sp_x_imm13_imm24(int x) {
	s1c17_cpu.sp -= s1c17_cpu.ext1 ? s1c17_0_imm13_imm24() : x;
	s1c17_cpu.sp = (unsigned)(s1c17_cpu.sp << 8) >> 8;
	s1c17_cpu.sp &= ~3;
}
//
static int s1c17_imm7_imm20_imm24() {
	int x = s1c17_cpu.code.x16 & 0x7F;			/* 00000000 00000000 00000000 0xxxxxxx */
	if(s1c17_cpu.ext1) {
		x |= (s1c17_cpu.ext1 & 0x1FFF) << 7;		/* 00000000 0000yyyy yyyyyyyy yxxxxxxx */
		if(s1c17_cpu.ext2) {
			x |= s1c17_cpu.ext2 << 20;		/* ???????? zzzzyyyy yyyyyyyy yxxxxxxx */
			x = (unsigned)(x << 8) >> 8;		/* 00000000 zzzzzzzz zzzyyyyy yyyyyyyy */
		}
		s1c17_cpu.ext1 = s1c17_cpu.ext2 = 0;
	}
	return x;
}
static int s1c17_imm7_imm16() {
	return (unsigned short)s1c17_imm7_imm20_imm24();
}
static int s1c17_sp_imm7_sp_imm20_sp_imm24() {
	int x = s1c17_imm7_imm20_imm24() + s1c17_cpu.sp;
	return (unsigned)(x << 8) >> 8;
}
//
static int s1c17_sign7_sign16() {
	int x = s1c17_cpu.code.x16 & 0x7F;			/* 00000000 00000000 00000000 0xxxxxxx */
	if(!s1c17_cpu.ext1) {
		x = (char)(x << 1) >> 1;			/* ssssssss ssssssss ssssssss sxxxxxxx */
	} else {
		x |= s1c17_cpu.ext1 << 7;			/* 00000000 0??????? yyyyyyyy yxxxxxxx */
		x = (short)x;					/* ssssssss ssssssss yyyyyyyy yxxxxxxx */
		s1c17_cpu.ext1 = s1c17_cpu.ext2 = 0;
	}
	return x;
}
static int s1c17_sign11_sign24() {
	int x = (s1c17_cpu.code.x16 & 0x3FF) << 1;		/* 00000000 00000000 00000xxx xxxxxxx0 */
	if(!s1c17_cpu.ext1) {
		x = (short)(x << 5) >> 5;			/* ssssssss ssssssss sssssxxx xxxxxxx0 */
	} else {
		x |= s1c17_cpu.ext1 << 11;			/* 00000??? yyyyyyyy yyyyyxxx xxxxxxx0 */
		x = (x << 8) >> 8;				/* ssssssss yyyyyyyy yyyyyxxx xxxxxxx0 */
		s1c17_cpu.ext1 = s1c17_cpu.ext2 = 0;
	}
	return x;
}
static int s1c17_sign8_sign21_sign24() {
	int x = (s1c17_cpu.code.x16 & 0x7F) << 1;		/* 00000000 00000000 00000000 xxxxxxx0 */
	if(!s1c17_cpu.ext1) {
		x = (char)x;					/* ssssssss ssssssss ssssssss xxxxxxx0 */
	} else {
		if(!s1c17_cpu.ext2) {
			x |= s1c17_cpu.ext1 << 8;		/* 00000000 ???yyyyy yyyyyyyy xxxxxxx0 */
			x = (x << 11) >> 11;			/* ssssssss sssyyyyy yyyyyyyy xxxxxxx0 */
		} else {
			x |= (s1c17_cpu.ext1 & 0x1FFF) << 8;	/* 00000000 000yyyyy yyyyyyyy xxxxxxx0 */
			x |= s1c17_cpu.ext2 << 21;		/* ???????? zzzyyyyy yyyyyyyy xxxxxxx0 */
			x = (x << 8) >> 8;			/* ssssssss zzzzzzzz zzzyyyyy yyyyyyyy */
		}
		s1c17_cpu.ext1 = s1c17_cpu.ext2 = 0;
	}
	return x;
}

/*--------------------------------------------------------------------------*/
/* ZpZ߂̋ʏ */

/*
		Asm()

s1c17_adc:
		Xld.b		%r11, [s1c17_cpu.psr]		;// %r11 := old_psr
		Xand		%r15, %r11, 0xF0		;// %r15 := old_psr & ~CVZN

		Xsll		%r12, 16			;// %r12[31:16] := x
		Xsll		%r13, 16			;// %r13[31:16] := y
		Xoor		%r13, %r13, 0xFFFF		;// %r13[15: 0] := 0xFFFF

		rr		%r11, 4				;// %r11[31]    := C
		add		%r11, %r11			;// %psr[C]     := C
		adc		%r10, %r13			;// %r10[31:16] := z = x + y + C

		ld.w		%r11, %psr			;// %r11 := new_psr
		Xsrl		%r10, 16			;// %r10 := z
		jrne.d		3
		 and		%r11, 0x0D			;// %r11 :=  new_psr & CV0N	*delay*
		 or		%r11, 0x02			;// %r11 :=  new_psr & CVZN
		or		%r11, %r15			;// %r11 := (new_psr & CVZN) | (old_psr & ~CVZN)
		Xld.b		[s1c17_cpu.psr], %r11

		ret

s1c17_sbc:
		Xld.b		%r11, [s1c17_cpu.psr]		;// %r11 := old_psr
		Xand		%r15, %r11, 0xF0		;// %r15 := old_psr & ~CVZN

		Xsll		%r12, 16			;// %r12[31:16] := x
		Xsll		%r13, 16			;// %r13[31:16] := y

		rr		%r11, 4				;// %r11[31]    := C
		add		%r11, %r11			;// %psr[C]     := C
		sbc		%r10, %r13			;// %r10[31:16] := z = x - y - C

		ld.w		%r11, %psr			;// %r11 := new_psr
		Xsrl		%r10, 16			;// %r10 := z
		jrne.d		3
		 and		%r11, 0x0D			;// %r11 :=  new_psr & CV0N	*delay*
		 or		%r11, 0x02			;// %r11 :=  new_psr & CVZN
		or		%r11, %r15			;// %r11 := (new_psr & CVZN) | (old_psr & ~CVZN)
		Xld.b		[s1c17_cpu.psr], %r11

		ret
*/

static int s1c17_adc(int x, int y) {
	int t = (x <<= 16) + (y <<= 16);
	int z = t + s1c17_cpu.psr.c + 0xFFFF;
	s1c17_cpu.psr.n = z < 0;
	s1c17_cpu.psr.v = (~(x ^ y) & (x ^ z)) < 0;
	s1c17_cpu.psr.c = ((unsigned)t < (unsigned)x) || ((unsigned)z < (unsigned)x);
	z = (unsigned)z >> 16;
	s1c17_cpu.psr.z = !z;
	return z;
}
static int s1c17_add(int x, int y) {
	s1c17_cpu.psr.c = 0;
	return s1c17_adc(x, y);
}
static int s1c17_sbc(int x, int y) {
	int t = (x <<= 16) - (y <<= 16);
	int z = t - s1c17_cpu.psr.c;
	s1c17_cpu.psr.n = z < 0;
	s1c17_cpu.psr.v = ((x ^ y) & (x ^ z)) < 0;
	s1c17_cpu.psr.c = ((unsigned)t > (unsigned)x) || ((unsigned)z > (unsigned)x);
	z = (unsigned)z >> 16;
	s1c17_cpu.psr.z = !z;
	return z;
}
static int s1c17_sub(int x, int y) {
	s1c17_cpu.psr.c = 0;
	return s1c17_sbc(x, y);
}

/*--------------------------------------------------------------------------*/
/* AhXZ߂̋ʏ */

static int s1c17_add_a(int x, int y) {
	x += y;
	return (unsigned)(x << 8) >> 8;
}
static int s1c17_sub_a(int x, int y) {
	x -= y;
	return (unsigned)(x << 8) >> 8;
}
static void s1c17_cmp_a(int x, int y) {
	x -= y;
	s1c17_cpu.psr.z = !x;
	s1c17_cpu.psr.c = x < 0;
}

/*--------------------------------------------------------------------------*/
/* _Z߂̋ʏ */

/*
		Asm()

s1c17_and:
		ld.h		%r12, %r12			;// %r12 := x = (short)x
		ld.h		%r13, %r13			;// %r13 := y = (short)y
		jp.d		s1c17_and_or_xor_not
		and		%r12, %r13			;// %r12 := x & y	*delay*
s1c17_or:
		ld.h		%r12, %r12			;// %r12 := x = (short)x
		ld.h		%r13, %r13			;// %r13 := y = (short)y
		jp.d		s1c17_and_or_xor_not
		or		%r12, %r13			;// %r12 := x | y	*delay*
s1c17_xor:
		ld.h		%r12, %r12			;// %r12 := x = (short)x
		ld.h		%r13, %r13			;// %r13 := y = (short)y
		jp.d		s1c17_and_or_xor_not
		xor		%r12, %r13			;// %r12 := x ^ y	*delay*
s1c17_not:
		ld.h		%r13, %r13			;// %r13 :=  y = (short)y
		not		%r12, %r13			;// %r12 := ~y
s1c17_and_or_xor_not:
		ld.w		%r13, %psr			;// %r13 := new_psr
		Xld.w		%r14, s1c17_cpu.psr		;// %r14 :=                     &s1c17_cpu.psr
		ld.b		%r15, [%r14]			;// %r15 :=            old_psr = s1c17_cpu.psr
		and		%r13, 11			;// %r13 := new_psr &= C0ZN
		and		%r15, -16			;// %r15 :=            old_psr &= ~CVZN
		or		%r13, %r15			;// %r13 := new_psr |= old_psr
		ld.b		[%r14], %r15			;// s1c17_cpu.psr := new_psr
		ret.d
		ld.w		%r10, %r12			;// %r10 := x op y	*delay*
*/

static int s1c17_and(int x, int y) {
	x = (short)x & (short)y;
	s1c17_cpu.psr.n = x < 0;
	s1c17_cpu.psr.z = !x;
	s1c17_cpu.psr.v = 0;
	return (unsigned short)x;
}
static int s1c17_or(int x, int y) {
	x = (short)x | (short)y;
	s1c17_cpu.psr.n = x < 0;
	s1c17_cpu.psr.z = !x;
	s1c17_cpu.psr.v = 0;
	return (unsigned short)x;
}
static int s1c17_xor(int x, int y) {
	x = (short)x ^ (short)y;
	s1c17_cpu.psr.n = x < 0;
	s1c17_cpu.psr.z = !x;
	s1c17_cpu.psr.v = 0;
	return (unsigned short)x;
}
static int s1c17_not(int x) {
	x = ~(short)x;
	s1c17_cpu.psr.n = x < 0;
	s1c17_cpu.psr.z = !x;
	s1c17_cpu.psr.v = 0;
	return (unsigned short)x;
}

/*--------------------------------------------------------------------------*/
/* 򖽗߂̋ʏ */

static void s1c17_jpa(int x, int d) {
	if(d) {
		s1c17_cpu_exec();
	}
	s1c17_cpu.pc = x & ~1;
}
static void s1c17_jpr(int x, int d) {
	x += s1c17_cpu.pc;
	x = (unsigned)(x << 8) >> 8;
	s1c17_jpa(x, d);
}

static void s1c17_calla(int x, int d) {
	s1c17_cpu.sp -= 4;
	if(d) {
		s1c17_cpu_exec();
	}
	s1c17_bcu_write(4, s1c17_cpu.sp, s1c17_cpu.pc);
	s1c17_cpu.pc = x & ~1;
}
static void s1c17_call(int x, int d) {
	x += s1c17_cpu.pc;
	x = (unsigned)(x << 8) >> 8;
	s1c17_calla(x, d);
}

static void s1c17_int(int no) {
	s1c17_cpu.sp -= 4;
	s1c17_bcu_write(4, s1c17_cpu.sp, s1c17_cpu.pc | (*(unsigned char*)&s1c17_cpu.psr << 24));
	s1c17_cpu.pc = s1c17_bcu_read(4, s1c17_bcu_read(4, 0xFFFF80/*TTBR*/) + no * 4);
	s1c17_cpu.pc = (unsigned)(s1c17_cpu.pc << 8) >> 8;
	s1c17_cpu.pc &= ~1;
	s1c17_cpu.psr.ie = 0;
}

/*--------------------------------------------------------------------------*/
/* Vtg߂̋ʏ */

static int s1c17_sr(int x, int y) {
	y = (y < 4) ? y : (y < 8) ? 4 : 8;
	s1c17_cpu.psr.c = (x & 0x0001) ? 1 : 0;
	x = (unsigned short)x;
	x >>= y;
	s1c17_cpu.psr.z = !x;
	s1c17_cpu.psr.n = (x & 0x8000) ? 1 : 0;
	return x;
}
static int s1c17_sa(int x, int y) {
	y = (y < 4) ? y : (y < 8) ? 4 : 8;
	s1c17_cpu.psr.c = (x & 0x0001) ? 1 : 0;
	x = (short)x;
	x >>= y;
	x = (unsigned short)x;
	s1c17_cpu.psr.z = !x;
	s1c17_cpu.psr.n = (x & 0x8000) ? 1 : 0;
	return x;
}
static int s1c17_sl(int x, int y) {
	y = (y < 4) ? y : (y < 8) ? 4 : 8;
	s1c17_cpu.psr.c = (x & 0x8000) ? 1 : 0;
	x <<= y;
	x = (unsigned short)x;
	s1c17_cpu.psr.z = !x;
	s1c17_cpu.psr.n = (x & 0x8000) ? 1 : 0;
	return x;
}

/*--------------------------------------------------------------------------*/
/* RvZbT߂̋ʏ */

static void s1c17_ld_cw(int x, int y) {
	s1c17_cpu.coprocessor.operating_mode = y & 15;
	s1c17_cpu.coprocessor.output_mode = (y >> 4) & 7;
	if(!s1c17_cpu.coprocessor.operating_mode) {
		/* Initialization mode 0 */
		s1c17_cpu.coprocessor.arithmetic_result = 0;
	}
}
static int s1c17_ld_ca(int x, int y) {
	if(s1c17_cpu.coprocessor.operating_mode != 3) {
		s1c17_cpu.coprocessor.overflow_flag = 0;
	}
	if(s1c17_cpu.coprocessor.operating_mode & 1) {
		x = (short)x;
		y = (short)y;
	} else {
		x = (unsigned short)x;
		y = (unsigned short)y;
	}
	switch(s1c17_cpu.coprocessor.operating_mode) {
	//case 0: /* Initialization mode 0 */
	//case 1: /* Initialization mode 1 */
	//case 2: /* Initialization mode 2 */
	//case 3: /* Arithmetic results reading mode */
	case 4: /* Unsigned multiplication mode */
	case 5: /* Signed multiplication mode */
		s1c17_cpu.coprocessor.arithmetic_result = x * y;
		break;
	case 7: /* Signed product-sum operation mode */
		x *= y;
		     y = s1c17_cpu.coprocessor.arithmetic_result;
		         s1c17_cpu.coprocessor.arithmetic_result += x;
		s1c17_cpu.coprocessor.overflow_flag = (~(x ^ y) & (x ^ s1c17_cpu.coprocessor.arithmetic_result)) < 0;
		break;
	case 8: /* Unsigned division mode */
	case 9: /* Signed division mode */
		if(y) {
			((short*)&s1c17_cpu.coprocessor.arithmetic_result)[0] = x / y;
			((short*)&s1c17_cpu.coprocessor.arithmetic_result)[1] = x % y;
		} else {
			((short*)&s1c17_cpu.coprocessor.arithmetic_result)[0] = -1;
			((short*)&s1c17_cpu.coprocessor.arithmetic_result)[1] = x;
		}
		break;
	}
	s1c17_cpu.psr.n = 0;
	s1c17_cpu.psr.z = 0;
	s1c17_cpu.psr.v = s1c17_cpu.coprocessor.overflow_flag;
	s1c17_cpu.psr.c = 0;
	if(!s1c17_cpu.coprocessor.output_mode) {
		/* Last 16-bit output mode */
		return ((unsigned short*)&s1c17_cpu.coprocessor.arithmetic_result)[0];
	} else {
		/* First 16-bit output mode */
		return ((unsigned short*)&s1c17_cpu.coprocessor.arithmetic_result)[1];
	}
}
static void s1c17_ld_cf(int x, int y) {
	if(s1c17_cpu.coprocessor.operating_mode != 3) {
		s1c17_cpu.coprocessor.overflow_flag = 0;
	}
	switch(s1c17_cpu.coprocessor.operating_mode) {
	case 1: /* Initialization mode 1 */
		((short*)&s1c17_cpu.coprocessor.arithmetic_result)[0] = y;
		((short*)&s1c17_cpu.coprocessor.arithmetic_result)[1] = 0;
		break;
	case 2: /* Initialization mode 2 */
		((short*)&s1c17_cpu.coprocessor.arithmetic_result)[0] = y;
		((short*)&s1c17_cpu.coprocessor.arithmetic_result)[1] = x;
		break;
	}
	s1c17_cpu.psr.n = 0;
	s1c17_cpu.psr.z = 0;
	s1c17_cpu.psr.v = s1c17_cpu.coprocessor.overflow_flag;
	s1c17_cpu.psr.c = 0;
}

/*--------------------------------------------------------------------------*/
/* ߃Zbg */

/* ld.b %rd,%rs */
static void s1c17_ld_b_rd_rs(/*x6_rd_x4_rs*/) {
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	s1c17_cpu.r[rd] = (unsigned short)(char)s1c17_cpu.r[rs];
}
/* ld.b %rd,[%rb] */
static void s1c17_ld_b_rd_IrbI(/*x6_rd_x4_rb*/) { //s1c17_rb_rb_imm13_rb_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rb.rd;
	s1c17_cpu.r[rd] = (unsigned short)(char)s1c17_bcu_read(1, s1c17_rb_rb_imm13_rb_imm24());
}
/* ld.b %rd,[%rb]+ */
static void s1c17_ld_b_rd_IrbIp(/*x6_rd_x4_rb*/) { //s1c17_increment_rb_x_imm13_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rb.rd;
	int rb = s1c17_cpu.code.x6_rd_x4_rb.rb;
	s1c17_cpu.r[rd] = (unsigned short)(char)s1c17_bcu_read(1, s1c17_cpu.r[rb]);
	s1c17_increment_rb_x_imm13_imm24(1);
}
/* ld.b %rd,[%rb]- */
static void s1c17_ld_b_rd_IrbIm(/*x6_rd_x4_rb*/) { //s1c17_decrement_rb_x_imm13_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rb.rd;
	int rb = s1c17_cpu.code.x6_rd_x4_rb.rb;
	s1c17_cpu.r[rd] = (unsigned short)(char)s1c17_bcu_read(1, s1c17_cpu.r[rb]);
	s1c17_decrement_rb_x_imm13_imm24(1);
}
/* ld.b %rd,-[%rb] */
static void s1c17_ld_b_rd_mIrbI(/*x6_rd_x4_rb*/) { //s1c17_decrement_rb_x_imm13_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rb.rd;
	int rb = s1c17_cpu.code.x6_rd_x4_rb.rb;
	s1c17_decrement_rb_x_imm13_imm24(1);
	s1c17_cpu.r[rd] = (unsigned short)(char)s1c17_bcu_read(1, s1c17_cpu.r[rb]);
}
/* ld.b %rd,[%sp+imm7] */
static void s1c17_ld_b_rd_Isp_imm7I(/*x6_rd_imm7*/) { //s1c17_sp_imm7_sp_imm20_sp_imm24
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = (unsigned short)(char)s1c17_bcu_read(1, s1c17_sp_imm7_sp_imm20_sp_imm24());
}
/* ld.b %rd,[imm7] */
static void s1c17_ld_b_rd_Iimm7I(/*x6_rd_imm7*/) { //s1c17_imm7_imm20_imm24
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = (unsigned short)(char)s1c17_bcu_read(1, s1c17_imm7_imm20_imm24());
}
/* ld.b [%rb],%rs */
static void s1c17_ld_b_IrbI_rs(/*x6_rs_x4_rb*/) { //s1c17_rb_rb_imm13_rb_imm24
	int rs = s1c17_cpu.code.x6_rs_x4_rb.rs;
	s1c17_bcu_write(1, s1c17_rb_rb_imm13_rb_imm24(), s1c17_cpu.r[rs]);
}
/* ld.b [%rb]+,%rs */
static void s1c17_ld_b_IrbIp_rs(/*x6_rs_x4_rb*/) { //s1c17_increment_rb_x_imm13_imm24
	int rs = s1c17_cpu.code.x6_rs_x4_rb.rs;
	int rb = s1c17_cpu.code.x6_rs_x4_rb.rb;
	s1c17_bcu_write(1, s1c17_cpu.r[rb], s1c17_cpu.r[rs]);
	s1c17_increment_rb_x_imm13_imm24(1);
}
/* ld.b [%rb]-,%rs */
static void s1c17_ld_b_IrbIm_rs(/*x6_rs_x4_rb*/) { //s1c17_decrement_rb_x_imm13_imm24
	int rs = s1c17_cpu.code.x6_rs_x4_rb.rs;
	int rb = s1c17_cpu.code.x6_rs_x4_rb.rb;
	s1c17_bcu_write(1, s1c17_cpu.r[rb], s1c17_cpu.r[rs]);
	s1c17_decrement_rb_x_imm13_imm24(1);
}
/* ld.b -[%rb],%rs */
static void s1c17_ld_b_mIrbI_rs(/*x6_rs_x4_rb*/) { //s1c17_decrement_rb_x_imm13_imm24
	int rs = s1c17_cpu.code.x6_rs_x4_rb.rs;
	int rb = s1c17_cpu.code.x6_rs_x4_rb.rb;
	s1c17_decrement_rb_x_imm13_imm24(1);
	s1c17_bcu_write(1, s1c17_cpu.r[rb], s1c17_cpu.r[rs]);
}
/* ld.b [%sp+imm7],%rs */
static void s1c17_ld_b_Isp_imm7I_rs(/*x6_rs_imm7*/) { //s1c17_sp_imm7_sp_imm20_sp_imm24
	int rs = s1c17_cpu.code.x6_rs_imm7.rs;
	s1c17_bcu_write(1, s1c17_sp_imm7_sp_imm20_sp_imm24(), s1c17_cpu.r[rs]);
}
/* ld.b [imm7],%rs */
static void s1c17_ld_b_Iimm7I_rs(/*x6_rs_imm7*/) { //s1c17_imm7_imm20_imm24
	int rs = s1c17_cpu.code.x6_rs_imm7.rs;
	s1c17_bcu_write(1, s1c17_imm7_imm20_imm24(), s1c17_cpu.r[rs]);
}
/* ld.ub %rd,%rs */
static void s1c17_ld_ub_rd_rs(/*x6_rd_x4_rs*/) {
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	s1c17_cpu.r[rd] = (unsigned char)s1c17_cpu.r[rs];
}
/* ld.ub %rd,[%rb] */
static void s1c17_ld_ub_rd_IrbI(/*x6_rd_x4_rb*/) { //s1c17_rb_rb_imm13_rb_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rb.rd;
	s1c17_cpu.r[rd] = s1c17_bcu_read(1, s1c17_rb_rb_imm13_rb_imm24());
}
/* ld.ub %rd,[%rb]+ */
static void s1c17_ld_ub_rd_IrbIp(/*x6_rd_x4_rb*/) { //s1c17_increment_rb_x_imm13_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rb.rd;
	int rb = s1c17_cpu.code.x6_rd_x4_rb.rb;
	s1c17_cpu.r[rd] = s1c17_bcu_read(1, s1c17_cpu.r[rb]);
	s1c17_increment_rb_x_imm13_imm24(1);
}
/* ld.ub %rd,[%rb]- */
static void s1c17_ld_ub_rd_IrbIm(/*x6_rd_x4_rb*/) { //s1c17_decrement_rb_x_imm13_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rb.rd;
	int rb = s1c17_cpu.code.x6_rd_x4_rb.rb;
	s1c17_cpu.r[rd] = s1c17_bcu_read(1, s1c17_cpu.r[rb]);
	s1c17_decrement_rb_x_imm13_imm24(1);
}
/* ld.ub %rd,-[%rb] */
static void s1c17_ld_ub_rd_mIrbI(/*x6_rd_x4_rb*/) { //s1c17_decrement_rb_x_imm13_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rb.rd;
	int rb = s1c17_cpu.code.x6_rd_x4_rb.rb;
	s1c17_decrement_rb_x_imm13_imm24(1);
	s1c17_cpu.r[rd] = s1c17_bcu_read(1, s1c17_cpu.r[rb]);
}
/* ld.ub %rd,[%sp+imm7] */
static void s1c17_ld_ub_rd_Isp_imm7I(/*x6_rd_imm7*/) { //s1c17_sp_imm7_sp_imm20_sp_imm24
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = s1c17_bcu_read(1, s1c17_sp_imm7_sp_imm20_sp_imm24());
}
/* ld.ub %rd,[imm7] */
static void s1c17_ld_ub_rd_Iimm7I(/*x6_rd_imm7*/) { //s1c17_imm7_imm20_imm24
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = s1c17_bcu_read(1, s1c17_imm7_imm20_imm24());
}
/* ld %rd,%rs */
static void s1c17_ld_rd_rs(/*x6_rd_x4_rs*/) {
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	s1c17_cpu.r[rd] = (unsigned short)s1c17_cpu.r[rs];
}
/* ld %rd,sign7 */
static void s1c17_ld_rd_sign7(/*x6_rd_sign7*/) { //s1c17_sign7_sign16
	int rd = s1c17_cpu.code.x6_rd_sign7.rd;
	s1c17_cpu.r[rd] = (unsigned short)s1c17_sign7_sign16();
}
/* ld %rd,[%rb] */
static void s1c17_ld_rd_IrbI(/*x6_rd_x4_rb*/) { //s1c17_rb_rb_imm13_rb_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rb.rd;
	s1c17_cpu.r[rd] = s1c17_bcu_read(2, s1c17_rb_rb_imm13_rb_imm24());
}
/* ld %rd,[%rb]+ */
static void s1c17_ld_rd_IrbIp(/*x6_rd_x4_rb*/) { //s1c17_increment_rb_x_imm13_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rb.rd;
	int rb = s1c17_cpu.code.x6_rd_x4_rb.rb;
	s1c17_cpu.r[rd] = s1c17_bcu_read(2, s1c17_cpu.r[rb]);
	s1c17_increment_rb_x_imm13_imm24(2);
}
/* ld %rd,[%rb]- */
static void s1c17_ld_rd_IrbIm(/*x6_rd_x4_rb*/) { //s1c17_decrement_rb_x_imm13_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rb.rd;
	int rb = s1c17_cpu.code.x6_rd_x4_rb.rb;
	s1c17_cpu.r[rd] = s1c17_bcu_read(2, s1c17_cpu.r[rb]);
	s1c17_decrement_rb_x_imm13_imm24(2);
}
/* ld %rd,-[%rb] */
static void s1c17_ld_rd_mIrbI(/*x6_rd_x4_rb*/) { //s1c17_decrement_rb_x_imm13_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rb.rd;
	int rb = s1c17_cpu.code.x6_rd_x4_rb.rb;
	s1c17_decrement_rb_x_imm13_imm24(2);
	s1c17_cpu.r[rd] = s1c17_bcu_read(2, s1c17_cpu.r[rb]);
}
/* ld %rd,[%sp+imm7] */
static void s1c17_ld_rd_Isp_imm7I(/*x6_rd_imm7*/) { //s1c17_sp_imm7_sp_imm20_sp_imm24
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = s1c17_bcu_read(2, s1c17_sp_imm7_sp_imm20_sp_imm24());
}
/* ld %rd,[imm7] */
static void s1c17_ld_rd_Iimm7I(/*x6_rd_imm7*/) { //s1c17_imm7_imm20_imm24
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = s1c17_bcu_read(2, s1c17_imm7_imm20_imm24());
}
/* ld [%rb],%rs */
static void s1c17_ld_IrbI_rs(/*x6_rs_x4_rb*/) { //s1c17_rb_rb_imm13_rb_imm24
	int rs = s1c17_cpu.code.x6_rs_x4_rb.rs;
	s1c17_bcu_write(2, s1c17_rb_rb_imm13_rb_imm24(), s1c17_cpu.r[rs]);
}
/* ld [%rb]+,%rs */
static void s1c17_ld_IrbIp_rs(/*x6_rs_x4_rb*/) { //s1c17_increment_rb_x_imm13_imm24
	int rs = s1c17_cpu.code.x6_rs_x4_rb.rs;
	int rb = s1c17_cpu.code.x6_rs_x4_rb.rb;
	s1c17_bcu_write(2, s1c17_cpu.r[rb], s1c17_cpu.r[rs]);
	s1c17_increment_rb_x_imm13_imm24(2);
}
/* ld [%rb]-,%rs */
static void s1c17_ld_IrbIm_rs(/*x6_rs_x4_rb*/) { //s1c17_decrement_rb_x_imm13_imm24
	int rs = s1c17_cpu.code.x6_rs_x4_rb.rs;
	int rb = s1c17_cpu.code.x6_rs_x4_rb.rb;
	s1c17_bcu_write(2, s1c17_cpu.r[rb], s1c17_cpu.r[rs]);
	s1c17_decrement_rb_x_imm13_imm24(2);
}
/* ld -[%rb],%rs */
static void s1c17_ld_mIrbI_rs(/*x6_rs_x4_rb*/) { //s1c17_decrement_rb_x_imm13_imm24
	int rs = s1c17_cpu.code.x6_rs_x4_rb.rs;
	int rb = s1c17_cpu.code.x6_rs_x4_rb.rb;
	s1c17_decrement_rb_x_imm13_imm24(2);
	s1c17_bcu_write(2, s1c17_cpu.r[rb], s1c17_cpu.r[rs]);
}
/* ld [%sp+imm7],%rs */
static void s1c17_ld_Isp_imm7I_rs(/*x6_rs_imm7*/) { //s1c17_sp_imm7_sp_imm20_sp_imm24
	int rs = s1c17_cpu.code.x6_rs_imm7.rs;
	s1c17_bcu_write(2, s1c17_sp_imm7_sp_imm20_sp_imm24(), s1c17_cpu.r[rs]);
}
/* ld [imm7],%rs */
static void s1c17_ld_Iimm7I_rs(/*x6_rs_imm7*/) { //s1c17_imm7_imm20_imm24
	int rs = s1c17_cpu.code.x6_rs_imm7.rs;
	s1c17_bcu_write(2, s1c17_imm7_imm20_imm24(), s1c17_cpu.r[rs]);
}
/* ld.a %rd,%rs */
static void s1c17_ld_a_rd_rs(/*x6_rd_x4_rs*/) {
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	s1c17_cpu.r[rd] = s1c17_cpu.r[rs];
}
/* ld.a %rd,imm7 */
static void s1c17_ld_a_rd_imm7(/*x6_rd_imm7*/) { //s1c17_imm7_imm20_imm24
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = s1c17_imm7_imm20_imm24();
}
/* ld.a %rd,[%rb] */
static void s1c17_ld_a_rd_IrbI(/*x6_rd_x4_rb*/) { //s1c17_rb_rb_imm13_rb_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rb.rd;
	s1c17_cpu.r[rd] = s1c17_bcu_read(4, s1c17_rb_rb_imm13_rb_imm24());
	s1c17_cpu.r[rd] = (unsigned)(s1c17_cpu.r[rd] << 8) >> 8;
}
/* ld.a %rd,[%rb]+ */
static void s1c17_ld_a_rd_IrbIp(/*x6_rd_x4_rb*/) { //s1c17_increment_rb_x_imm13_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rb.rd;
	int rb = s1c17_cpu.code.x6_rd_x4_rb.rb;
	s1c17_cpu.r[rd] = s1c17_bcu_read(4, s1c17_cpu.r[rb]);
	s1c17_cpu.r[rd] = (unsigned)(s1c17_cpu.r[rd] << 8) >> 8;
	s1c17_increment_rb_x_imm13_imm24(4);
}
/* ld.a %rd,[%rb]- */
static void s1c17_ld_a_rd_IrbIm(/*x6_rd_x4_rb*/) { //s1c17_decrement_rb_x_imm13_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rb.rd;
	int rb = s1c17_cpu.code.x6_rd_x4_rb.rb;
	s1c17_cpu.r[rd] = s1c17_bcu_read(4, s1c17_cpu.r[rb]);
	s1c17_cpu.r[rd] = (unsigned)(s1c17_cpu.r[rd] << 8) >> 8;
	s1c17_decrement_rb_x_imm13_imm24(4);
}
/* ld.a %rd,-[%rb] */
static void s1c17_ld_a_rd_mIrbI(/*x6_rd_x4_rb*/) { //s1c17_decrement_rb_x_imm13_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rb.rd;
	int rb = s1c17_cpu.code.x6_rd_x4_rb.rb;
	s1c17_decrement_rb_x_imm13_imm24(4);
	s1c17_cpu.r[rd] = s1c17_bcu_read(4, s1c17_cpu.r[rb]);
	s1c17_cpu.r[rd] = (unsigned)(s1c17_cpu.r[rd] << 8) >> 8;
}
/* ld.a %rd,[%sp+imm7] */
static void s1c17_ld_a_rd_Isp_imm7I(/*x6_rd_imm7*/) { //s1c17_sp_imm7_sp_imm20_sp_imm24
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = s1c17_bcu_read(4, s1c17_sp_imm7_sp_imm20_sp_imm24());
	s1c17_cpu.r[rd] = (unsigned)(s1c17_cpu.r[rd] << 8) >> 8;
}
/* ld.a %rd,[imm7] */
static void s1c17_ld_a_rd_Iimm7I(/*x6_rd_imm7*/) { //s1c17_imm7_imm20_imm24
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = s1c17_bcu_read(4, s1c17_imm7_imm20_imm24());
	s1c17_cpu.r[rd] = (unsigned)(s1c17_cpu.r[rd] << 8) >> 8;
}
/* ld.a [%rb],%rs */
static void s1c17_ld_a_IrbI_rs(/*x6_rs_x4_rb*/) { //s1c17_rb_rb_imm13_rb_imm24
	int rs = s1c17_cpu.code.x6_rs_x4_rb.rs;
	s1c17_bcu_write(4, s1c17_rb_rb_imm13_rb_imm24(), s1c17_cpu.r[rs]);
}
/* ld.a [%rb]+,%rs */
static void s1c17_ld_a_IrbIp_rs(/*x6_rs_x4_rb*/) { //s1c17_increment_rb_x_imm13_imm24
	int rs = s1c17_cpu.code.x6_rs_x4_rb.rs;
	int rb = s1c17_cpu.code.x6_rs_x4_rb.rb;
	s1c17_bcu_write(4, s1c17_cpu.r[rb], s1c17_cpu.r[rs]);
	s1c17_increment_rb_x_imm13_imm24(4);
}
/* ld.a [%rb]-,%rs */
static void s1c17_ld_a_IrbIm_rs(/*x6_rs_x4_rb*/) { //s1c17_decrement_rb_x_imm13_imm24
	int rs = s1c17_cpu.code.x6_rs_x4_rb.rs;
	int rb = s1c17_cpu.code.x6_rs_x4_rb.rb;
	s1c17_bcu_write(4, s1c17_cpu.r[rb], s1c17_cpu.r[rs]);
	s1c17_decrement_rb_x_imm13_imm24(4);
}
/* ld.a -[%rb],%rs */
static void s1c17_ld_a_mIrbI_rs(/*x6_rs_x4_rb*/) { //s1c17_decrement_rb_x_imm13_imm24
	int rs = s1c17_cpu.code.x6_rs_x4_rb.rs;
	int rb = s1c17_cpu.code.x6_rs_x4_rb.rb;
	s1c17_decrement_rb_x_imm13_imm24(4);
	s1c17_bcu_write(4, s1c17_cpu.r[rb], s1c17_cpu.r[rs]);
}
/* ld.a [%sp+imm7],%rs */
static void s1c17_ld_a_Isp_imm7I_rs(/*x6_rs_imm7*/) { //s1c17_sp_imm7_sp_imm20_sp_imm24
	int rs = s1c17_cpu.code.x6_rs_imm7.rs;
	s1c17_bcu_write(4, s1c17_sp_imm7_sp_imm20_sp_imm24(), s1c17_cpu.r[rs]);
}
/* ld.a [imm7],%rs */
static void s1c17_ld_a_Iimm7I_rs(/*x6_rs_imm7*/) { //s1c17_imm7_imm20_imm24
	int rs = s1c17_cpu.code.x6_rs_imm7.rs;
	s1c17_bcu_write(4, s1c17_imm7_imm20_imm24(), s1c17_cpu.r[rs]);
}
/* ld.a %rd,%sp */
static void s1c17_ld_a_rd_sp(/*x6_rd_x7*/) {
	int rd = s1c17_cpu.code.x6_rd_x7.rd;
	s1c17_cpu.r[rd] = s1c17_cpu.sp;
}
/* ld.a %rd,%pc */
static void s1c17_ld_a_rd_pc(/*x6_rd_x7*/) {
	int rd = s1c17_cpu.code.x6_rd_x7.rd;
	s1c17_cpu.r[rd] = s1c17_cpu.pc;
}
/* ld.a %rd,[%sp] */
static void s1c17_ld_a_rd_IspI(/*x6_rd_x7*/) { //s1c17_sp_sp_imm13_sp_imm24
	int rd = s1c17_cpu.code.x6_rd_x7.rd;
	s1c17_cpu.r[rd] = s1c17_bcu_read(4, s1c17_sp_sp_imm13_sp_imm24());
	s1c17_cpu.r[rd] = (unsigned)(s1c17_cpu.r[rd] << 8) >> 8;
}
/* ld.a %rd,[%sp]+ */
static void s1c17_ld_a_rd_IspIp(/*x6_rd_x7*/) { //s1c17_increment_sp_x_imm13_imm24
	int rd = s1c17_cpu.code.x6_rd_x7.rd;
	s1c17_cpu.r[rd] = s1c17_bcu_read(4, s1c17_cpu.sp);
	s1c17_cpu.r[rd] = (unsigned)(s1c17_cpu.r[rd] << 8) >> 8;
	s1c17_increment_sp_x_imm13_imm24(4);
}
/* ld.a %rd,[%sp]- */
static void s1c17_ld_a_rd_IspIm(/*x6_rd_x7*/) { //s1c17_decrement_sp_x_imm13_imm24
	int rd = s1c17_cpu.code.x6_rd_x7.rd;
	s1c17_cpu.r[rd] = s1c17_bcu_read(4, s1c17_cpu.sp);
	s1c17_cpu.r[rd] = (unsigned)(s1c17_cpu.r[rd] << 8) >> 8;
	s1c17_decrement_sp_x_imm13_imm24(4);
}
/* ld.a %rd,-[%sp] */
static void s1c17_ld_a_rd_mIspI(/*x6_rd_x7*/) { //s1c17_decrement_sp_x_imm13_imm24
	int rd = s1c17_cpu.code.x6_rd_x7.rd;
	s1c17_decrement_rb_x_imm13_imm24(4);
	s1c17_cpu.r[rd] = s1c17_bcu_read(4, s1c17_cpu.sp);
	s1c17_cpu.r[rd] = (unsigned)(s1c17_cpu.r[rd] << 8) >> 8;
}
/* ld.a [%sp],%rs */
static void s1c17_ld_a_IspI_rs(/*x6_rs_x7*/) { //s1c17_sp_sp_imm13_sp_imm24
	int rs = s1c17_cpu.code.x6_rs_x7.rs;
	s1c17_bcu_write(4, s1c17_sp_sp_imm13_sp_imm24(), s1c17_cpu.r[rs]);
}
/* ld.a [%sp]+,%rs */
static void s1c17_ld_a_IspIp_rs(/*x6_rs_x7*/) { //s1c17_increment_sp_x_imm13_imm24
	int rs = s1c17_cpu.code.x6_rs_x7.rs;
	s1c17_bcu_write(4, s1c17_cpu.sp, s1c17_cpu.r[rs]);
	s1c17_increment_sp_x_imm13_imm24(4);
}
/* ld.a [%sp]-,%rs */
static void s1c17_ld_a_IspIm_rs(/*x6_rs_x7*/) { //s1c17_decrement_sp_x_imm13_imm24
	int rs = s1c17_cpu.code.x6_rs_x7.rs;
	s1c17_bcu_write(4, s1c17_cpu.sp, s1c17_cpu.r[rs]);
	s1c17_decrement_sp_x_imm13_imm24(4);
}
/* ld.a -[%sp],%rs */
static void s1c17_ld_a_mIspI_rs(/*x6_rs_x7*/) { //s1c17_decrement_sp_x_imm13_imm24
	int rs = s1c17_cpu.code.x6_rs_x7.rs;
	s1c17_decrement_sp_x_imm13_imm24(4);
	s1c17_bcu_write(4, s1c17_cpu.sp, s1c17_cpu.r[rs]);
}
/* ld.a %sp,%rs */
static void s1c17_ld_a_sp_rs(/*x6_rs_x7*/) {
	int rs = s1c17_cpu.code.x6_rs_x7.rs;
	s1c17_cpu.sp = s1c17_cpu.r[rs];
	s1c17_cpu.sp &= ~3;
}
/* ld.a %sp,imm7 */
static void s1c17_ld_a_sp_imm7(/*x9_imm7*/) { //s1c17_imm7_imm20_imm24
	s1c17_cpu.sp = s1c17_imm7_imm20_imm24();
	s1c17_cpu.sp &= ~3;
}
/* add %rd,%rs */
static void s1c17_add_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	if(!s1c17_cpu.ext1) {
		s1c17_cpu.r[rd] = s1c17_add(s1c17_cpu.r[rd], s1c17_cpu.r[rs]);
	} else {
		s1c17_cpu.r[rd] = s1c17_add(s1c17_cpu.r[rs], s1c17_0_imm13_imm16());
	}
}
/* add/c %rd,%rs */
static void s1c17_add_c_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(s1c17_cpu.psr.c) {
		s1c17_add_rd_rs();
		s1c17_cpu.psr.c = 1;
	}
}
/* add/nc %rd,%rs */
static void s1c17_add_nc_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(!s1c17_cpu.psr.c) {
		s1c17_add_rd_rs();
		s1c17_cpu.psr.c = 0;
	}
}
/* add %rd,imm7 */
static void s1c17_add_rd_imm7(/*x6_rd_imm7*/) { //s1c17_imm7_imm16
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = s1c17_add(s1c17_cpu.r[rd], s1c17_imm7_imm16());
}
/* add.a %rd,%rs */
static void s1c17_add_a_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	if(!s1c17_cpu.ext1) {
		s1c17_cpu.r[rd] = s1c17_add_a(s1c17_cpu.r[rd], s1c17_cpu.r[rs]);
	} else {
		s1c17_cpu.r[rd] = s1c17_add_a(s1c17_cpu.r[rs], s1c17_0_imm13_imm24());
	}
}
/* add.a/c %rd,%rs */
static void s1c17_add_a_c_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm24
	if(s1c17_cpu.psr.c) {
		s1c17_add_a_rd_rs();
	}
}
/* add.a/nc %rd,%rs */
static void s1c17_add_a_nc_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm24
	if(!s1c17_cpu.psr.c) {
		s1c17_add_a_rd_rs();
	}
}
/* add.a %sp,%rs */
static void s1c17_add_a_sp_rs(/*x13_rs*/) { //s1c17_0_imm13_imm24
	int rs = s1c17_cpu.code.x13_rs.rs;
	if(!s1c17_cpu.ext1) {
		s1c17_cpu.sp = s1c17_add_a(s1c17_cpu.sp, s1c17_cpu.r[rs]);
	} else {
		s1c17_cpu.sp = s1c17_add_a(s1c17_cpu.r[rs], s1c17_0_imm13_imm24());
	}
	s1c17_cpu.sp &= ~3;
}
/* add.a %rd,imm7 */
static void s1c17_add_a_rd_imm7(/*x6_rd_imm7*/) { //s1c17_imm7_imm20_imm24
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = s1c17_add_a(s1c17_cpu.r[rd], s1c17_imm7_imm20_imm24());
}
/* add.a %sp,imm7 */
static void s1c17_add_a_sp_imm7(/*x9_imm7*/) { //s1c17_imm7_imm20_imm24
	s1c17_cpu.sp = s1c17_add_a(s1c17_cpu.sp, s1c17_imm7_imm20_imm24());
	s1c17_cpu.sp &= ~3;
}
/* adc %rd,%rs */
static void s1c17_adc_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	if(!s1c17_cpu.ext1) {
		s1c17_cpu.r[rd] = s1c17_adc(s1c17_cpu.r[rd], s1c17_cpu.r[rs]);
	} else {
		s1c17_cpu.r[rd] = s1c17_adc(s1c17_cpu.r[rs], s1c17_0_imm13_imm16());
	}
}
/* adc/c %rd,%rs */
static void s1c17_adc_c_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(s1c17_cpu.psr.c) {
		s1c17_adc_rd_rs();
		s1c17_cpu.psr.c = 1;
	}
}
/* adc/nc %rd,%rs */
static void s1c17_adc_nc_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(!s1c17_cpu.psr.c) {
		s1c17_adc_rd_rs();
		s1c17_cpu.psr.c = 0;
	}
}
/* adc %rd,imm7 */
static void s1c17_adc_rd_imm7(/*x6_rd_imm7*/) { //s1c17_imm7_imm16
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = s1c17_adc(s1c17_cpu.r[rd], s1c17_imm7_imm16());
}
/* sub %rd,%rs */
static void s1c17_sub_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	if(!s1c17_cpu.ext1) {
		s1c17_cpu.r[rd] = s1c17_sub(s1c17_cpu.r[rd], s1c17_cpu.r[rs]);
	} else {
		s1c17_cpu.r[rd] = s1c17_sub(s1c17_cpu.r[rs], s1c17_0_imm13_imm16());
	}
}
/* sub/c %rd,%rs */
static void s1c17_sub_c_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(s1c17_cpu.psr.c) {
		s1c17_sub_rd_rs();
		s1c17_cpu.psr.c = 1;
	}
}
/* sub/nc %rd,%rs */
static void s1c17_sub_nc_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(!s1c17_cpu.psr.c) {
		s1c17_sub_rd_rs();
		s1c17_cpu.psr.c = 0;
	}
}
/* sub %rd,imm7 */
static void s1c17_sub_rd_imm7(/*x6_rd_imm7*/) { //s1c17_imm7_imm16
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = s1c17_sub(s1c17_cpu.r[rd], s1c17_imm7_imm16());
}
/* sub.a %rd,%rs */
static void s1c17_sub_a_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	if(!s1c17_cpu.ext1) {
		s1c17_cpu.r[rd] = s1c17_sub_a(s1c17_cpu.r[rd], s1c17_cpu.r[rs]);
	} else {
		s1c17_cpu.r[rd] = s1c17_sub_a(s1c17_cpu.r[rs], s1c17_0_imm13_imm24());
	}
}
/* sub.a/c %rd,%rs */
static void s1c17_sub_a_c_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm24
	if(s1c17_cpu.psr.c) {
		s1c17_sub_a_rd_rs();
	}
}
/* sub.a/nc %rd,%rs */
static void s1c17_sub_a_nc_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm24
	if(!s1c17_cpu.psr.c) {
		s1c17_sub_a_rd_rs();
	}
}
/* sub.a %sp,%rs */
static void s1c17_sub_a_sp_rs(/*x13_rs*/) { //s1c17_0_imm13_imm24
	int rs = s1c17_cpu.code.x13_rs.rs;
	if(!s1c17_cpu.ext1) {
		s1c17_cpu.sp = s1c17_sub_a(s1c17_cpu.sp, s1c17_cpu.r[rs]);
	} else {
		s1c17_cpu.sp = s1c17_sub_a(s1c17_cpu.r[rs], s1c17_0_imm13_imm24());
	}
	s1c17_cpu.sp &= ~3;
}
/* sub.a %rd,imm7 */
static void s1c17_sub_a_rd_imm7(/*x6_rd_imm7*/) { //s1c17_imm7_imm20_imm24
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = s1c17_sub_a(s1c17_cpu.r[rd], s1c17_imm7_imm20_imm24());
}
/* sub.a %sp,imm7 */
static void s1c17_sub_a_sp_imm7(/*x9_imm7*/) { //s1c17_imm7_imm20_imm24
	s1c17_cpu.sp = s1c17_sub_a(s1c17_cpu.sp, s1c17_imm7_imm20_imm24());
	s1c17_cpu.sp &= ~3;
}
/* sbc %rd,%rs */
static void s1c17_sbc_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	if(!s1c17_cpu.ext1) {
		s1c17_cpu.r[rd] = s1c17_sbc(s1c17_cpu.r[rd], s1c17_cpu.r[rs]);
	} else {
		s1c17_cpu.r[rd] = s1c17_sbc(s1c17_cpu.r[rs], s1c17_0_imm13_imm16());
	}
}
/* sbc/c %rd,%rs */
static void s1c17_sbc_c_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(s1c17_cpu.psr.c) {
		s1c17_sbc_rd_rs();
		s1c17_cpu.psr.c = 1;
	}
}
/* sbc/nc %rd,%rs */
static void s1c17_sbc_nc_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(!s1c17_cpu.psr.c) {
		s1c17_sbc_rd_rs();
		s1c17_cpu.psr.c = 0;
	}
}
/* sbc %rd,imm7 */
static void s1c17_sbc_rd_imm7(/*x6_rd_imm7*/) { //s1c17_imm7_imm16
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = s1c17_sbc(s1c17_cpu.r[rd], s1c17_imm7_imm16());
}
/* cmp %rd,%rs */
static void s1c17_cmp_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	if(!s1c17_cpu.ext1) {
		s1c17_sub(s1c17_cpu.r[rd], s1c17_cpu.r[rs]);
	} else {
		s1c17_sub(s1c17_cpu.r[rs], s1c17_0_imm13_imm16());
	}
}
/* cmp/c %rd,%rs */
static void s1c17_cmp_c_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(s1c17_cpu.psr.c) {
		s1c17_cmp_rd_rs();
		s1c17_cpu.psr.c = 1;
	}
}
/* cmp/nc %rd,%rs */
static void s1c17_cmp_nc_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(!s1c17_cpu.psr.c) {
		s1c17_cmp_rd_rs();
		s1c17_cpu.psr.c = 0;
	}
}
/* cmp %rd,sign7 */
static void s1c17_cmp_rd_sign7(/*x6_rd_sign7*/) { //s1c17_sign7_sign16
	int rd = s1c17_cpu.code.x6_rd_sign7.rd;
	s1c17_sub(s1c17_cpu.r[rd], s1c17_sign7_sign16());
}
/* cmp.a %rd,%rs */
static void s1c17_cmp_a_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm24
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	if(!s1c17_cpu.ext1) {
		s1c17_cmp_a(s1c17_cpu.r[rd], s1c17_cpu.r[rs]);
	} else {
		s1c17_cmp_a(s1c17_cpu.r[rs], s1c17_0_imm13_imm24());
	}
}
/* cmp.a/c %rd,%rs */
static void s1c17_cmp_a_c_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm24
	if(s1c17_cpu.psr.c) {
		s1c17_cmp_a_rd_rs();
		s1c17_cpu.psr.c = 1;
	}
}
/* cmp.a/nc %rd,%rs */
static void s1c17_cmp_a_nc_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm24
	if(!s1c17_cpu.psr.c) {
		s1c17_cmp_a_rd_rs();
		s1c17_cpu.psr.c = 0;
	}
}
/* cmp.a %rd,imm7 */
static void s1c17_cmp_a_rd_imm7(/*x6_rd_imm7*/) { //s1c17_imm7_imm20_imm24
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cmp_a(s1c17_cpu.r[rd], s1c17_imm7_imm20_imm24());
}
/* cmc %rd,%rs */
static void s1c17_cmc_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	if(!s1c17_cpu.ext1) {
		s1c17_sbc(s1c17_cpu.r[rd], s1c17_cpu.r[rs]);
	} else {
		s1c17_sbc(s1c17_cpu.r[rs], s1c17_0_imm13_imm16());
	}
}
/* cmc/c %rd,%rs */
static void s1c17_cmc_c_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(s1c17_cpu.psr.c) {
		s1c17_cmc_rd_rs();
		s1c17_cpu.psr.c = 1;
	}
}
/* cmc/nc %rd,%rs */
static void s1c17_cmc_nc_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(!s1c17_cpu.psr.c) {
		s1c17_cmc_rd_rs();
		s1c17_cpu.psr.c = 0;
	}
}
/* cmc %rd,sign7 */
static void s1c17_cmc_rd_sign7(/*x6_rd_sign7*/) { //s1c17_sign7_sign16
	int rd = s1c17_cpu.code.x6_rd_sign7.rd;
	s1c17_sbc(s1c17_cpu.r[rd], s1c17_sign7_sign16());
}
/* and %rd,%rs */
static void s1c17_and_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	if(!s1c17_cpu.ext1) {
		s1c17_cpu.r[rd] = s1c17_and(s1c17_cpu.r[rd], s1c17_cpu.r[rs]);
	} else {
		s1c17_cpu.r[rd] = s1c17_and(s1c17_cpu.r[rs], s1c17_0_imm13_imm16());
	}
}
/* and/c %rd,%rs */
static void s1c17_and_c_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(s1c17_cpu.psr.c) {
		s1c17_and_rd_rs();
	}
}
/* and/nc %rd,%rs */
static void s1c17_and_nc_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(!s1c17_cpu.psr.c) {
		s1c17_and_rd_rs();
	}
}
/* and %rd,sign7 */
static void s1c17_and_rd_sign7(/*x6_rd_sign7*/) { //s1c17_sign7_sign16
	int rd = s1c17_cpu.code.x6_rd_sign7.rd;
	s1c17_cpu.r[rd] = s1c17_and(s1c17_cpu.r[rd], s1c17_sign7_sign16());
}
/* or %rd,%rs */
static void s1c17_or_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	if(!s1c17_cpu.ext1) {
		s1c17_cpu.r[rd] = s1c17_or(s1c17_cpu.r[rd], s1c17_cpu.r[rs]);
	} else {
		s1c17_cpu.r[rd] = s1c17_or(s1c17_cpu.r[rs], s1c17_0_imm13_imm16());
	}
}
/* or/c %rd,%rs */
static void s1c17_or_c_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(s1c17_cpu.psr.c) {
		s1c17_or_rd_rs();
	}
}
/* or/nc %rd,%rs */
static void s1c17_or_nc_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(!s1c17_cpu.psr.c) {
		s1c17_or_rd_rs();
	}
}
/* or %rd,sign7 */
static void s1c17_or_rd_sign7(/*x6_rd_sign7*/) { //s1c17_sign7_sign16
	int rd = s1c17_cpu.code.x6_rd_sign7.rd;
	s1c17_cpu.r[rd] = s1c17_or(s1c17_cpu.r[rd], s1c17_sign7_sign16());
}
/* xor %rd,%rs */
static void s1c17_xor_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	if(!s1c17_cpu.ext1) {
		s1c17_cpu.r[rd] = s1c17_xor(s1c17_cpu.r[rd], s1c17_cpu.r[rs]);
	} else {
		s1c17_cpu.r[rd] = s1c17_xor(s1c17_cpu.r[rs], s1c17_0_imm13_imm16());
	}
}
/* xor/c %rd,%rs */
static void s1c17_xor_c_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(s1c17_cpu.psr.c) {
		s1c17_xor_rd_rs();
	}
}
/* xor/nc %rd,%rs */
static void s1c17_xor_nc_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(!s1c17_cpu.psr.c) {
		s1c17_xor_rd_rs();
	}
}
/* xor %rd,sign7 */
static void s1c17_xor_rd_sign7(/*x6_rd_sign7*/) { //s1c17_sign7_sign16
	int rd = s1c17_cpu.code.x6_rd_sign7.rd;
	s1c17_cpu.r[rd] = s1c17_xor(s1c17_cpu.r[rd], s1c17_sign7_sign16());
}
/* not %rd,%rs */
static void s1c17_not_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	if(!s1c17_cpu.ext1) {
		s1c17_cpu.r[rd] = s1c17_not(s1c17_cpu.r[rs]);
	} else {
		s1c17_cpu.r[rd] = s1c17_not(s1c17_0_imm13_imm16());
	}
}
/* not/c %rd,%rs */
static void s1c17_not_c_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(s1c17_cpu.psr.c) {
		s1c17_not_rd_rs();
	}
}
/* not/nc %rd,%rs */
static void s1c17_not_nc_rd_rs(/*x6_rd_x4_rs*/) { //s1c17_0_imm13_imm16
	if(!s1c17_cpu.psr.c) {
		s1c17_not_rd_rs();
	}
}
/* not %rd,sign7 */
static void s1c17_not_rd_sign7(/*x6_rd_sign7*/) { //s1c17_sign7_sign16
	int rd = s1c17_cpu.code.x6_rd_sign7.rd;
	s1c17_cpu.r[rd] = s1c17_not(s1c17_sign7_sign16());
}
/* jpr(.d) sign10 */
static void s1c17_jpr_sign10(/*x5_d_sign10*/) { //s1c17_sign11_sign24
	int d = s1c17_cpu.code.x5_d_sign10.d;
	s1c17_jpr(s1c17_sign11_sign24(), d);
}
/* jpr(.d) %rb */
static void s1c17_jpr_rb(/*x8_d_x4_rb*/) {
	int d = s1c17_cpu.code.x8_d_x4_rb.d;
	int rb = s1c17_cpu.code.x8_d_x4_rb.rb;
	s1c17_jpr(s1c17_cpu.r[rb], d);
}
/* jpa(.d) imm7 */
static void s1c17_jpa_imm7(/*x8_d_imm7*/) { //s1c17_imm7_imm20_imm24
	int d = s1c17_cpu.code.x8_d_imm7.d;
	s1c17_jpa(s1c17_imm7_imm20_imm24(), d);
}
/* jpa(.d) %rb */
static void s1c17_jpa_rb(/*x8_d_x4_rb*/) {
	int d = s1c17_cpu.code.x8_d_x4_rb.d;
	int rb = s1c17_cpu.code.x8_d_x4_rb.rb;
	s1c17_jpa(s1c17_cpu.r[rb], d);
}
/* jrgt(.d) sign7 */
static void s1c17_jrgt_sign7(/*x8_d_sign7*/) { //s1c17_sign8_sign21_sign24
	if(!(s1c17_cpu.psr.z | (s1c17_cpu.psr.n ^ s1c17_cpu.psr.v))) {
		int d = s1c17_cpu.code.x8_d_sign7.d;
		s1c17_jpr(s1c17_sign8_sign21_sign24(), d);
	}
}
/* jrge(.d) sign7 */
static void s1c17_jrge_sign7(/*x8_d_sign7*/) { //s1c17_sign8_sign21_sign24
	if(!(s1c17_cpu.psr.n ^ s1c17_cpu.psr.v)) {
		int d = s1c17_cpu.code.x8_d_sign7.d;
		s1c17_jpr(s1c17_sign8_sign21_sign24(), d);
	}
}
/* jrlt(.d) sign7 */
static void s1c17_jrlt_sign7(/*x8_d_sign7*/) { //s1c17_sign8_sign21_sign24
	if(s1c17_cpu.psr.n ^ s1c17_cpu.psr.v) {
		int d = s1c17_cpu.code.x8_d_sign7.d;
		s1c17_jpr(s1c17_sign8_sign21_sign24(), d);
	}
}
/* jrle(.d) sign7 */
static void s1c17_jrle_sign7(/*x8_d_sign7*/) { //s1c17_sign8_sign21_sign24
	if(s1c17_cpu.psr.z | (s1c17_cpu.psr.n ^ s1c17_cpu.psr.v)) {
		int d = s1c17_cpu.code.x8_d_sign7.d;
		s1c17_jpr(s1c17_sign8_sign21_sign24(), d);
	}
}
/* jrugt(.d) sign7 */
static void s1c17_jrugt_sign7(/*x8_d_sign7*/) { //s1c17_sign8_sign21_sign24
	if(!(s1c17_cpu.psr.z | s1c17_cpu.psr.c)) {
		int d = s1c17_cpu.code.x8_d_sign7.d;
		s1c17_jpr(s1c17_sign8_sign21_sign24(), d);
	}
}
/* jruge(.d) sign7 */
static void s1c17_jruge_sign7(/*x8_d_sign7*/) { //s1c17_sign8_sign21_sign24
	if(!s1c17_cpu.psr.c) {
		int d = s1c17_cpu.code.x8_d_sign7.d;
		s1c17_jpr(s1c17_sign8_sign21_sign24(), d);
	}
}
/* jrult(.d) sign7 */
static void s1c17_jrult_sign7(/*x8_d_sign7*/) { //s1c17_sign8_sign21_sign24
	if(s1c17_cpu.psr.c) {
		int d = s1c17_cpu.code.x8_d_sign7.d;
		s1c17_jpr(s1c17_sign8_sign21_sign24(), d);
	}
}
/* jrule(.d) sign7 */
static void s1c17_jrule_sign7(/*x8_d_sign7*/) { //s1c17_sign8_sign21_sign24
	if(s1c17_cpu.psr.z | s1c17_cpu.psr.c) {
		int d = s1c17_cpu.code.x8_d_sign7.d;
		s1c17_jpr(s1c17_sign8_sign21_sign24(), d);
	}
}
/* jreq(.d) sign7 */
static void s1c17_jreq_sign7(/*x8_d_sign7*/) { //s1c17_sign8_sign21_sign24
	if(s1c17_cpu.psr.z) {
		int d = s1c17_cpu.code.x8_d_sign7.d;
		s1c17_jpr(s1c17_sign8_sign21_sign24(), d);
	}
}
/* jrne(.d) sign7 */
static void s1c17_jrne_sign7(/*x8_d_sign7*/) { //s1c17_sign8_sign21_sign24
	if(!s1c17_cpu.psr.z) {
		int d = s1c17_cpu.code.x8_d_sign7.d;
		s1c17_jpr(s1c17_sign8_sign21_sign24(), d);
	}
}
/* call(.d) sign10 */
static void s1c17_call_sign10(/*x5_d_sign10*/) { //s1c17_sign11_sign24
	int d = s1c17_cpu.code.x5_d_sign10.d;
	s1c17_call(s1c17_sign11_sign24(), d);
}
/* call(.d) %rb */
static void s1c17_call_rb(/*x8_d_x4_rb*/) {
	int d = s1c17_cpu.code.x8_d_x4_rb.d;
	int rb = s1c17_cpu.code.x8_d_x4_rb.rb;
	s1c17_call(s1c17_cpu.r[rb], d);
}
/* calla(.d) imm7 */
static void s1c17_calla_imm7(/*x8_d_imm7*/) { //s1c17_imm7_imm20_imm24
	int d = s1c17_cpu.code.x8_d_imm7.d;
	s1c17_calla(s1c17_imm7_imm20_imm24(), d);
}
/* calla(.d) %rb */
static void s1c17_calla_rb(/*x8_d_x4_rb*/) {
	int d = s1c17_cpu.code.x8_d_x4_rb.d;
	int rb = s1c17_cpu.code.x8_d_x4_rb.rb;
	s1c17_calla(s1c17_cpu.r[rb], d);
}
/* ret(.d) */
static void s1c17_ret(/*x8_d_x7*/) {
	s1c17_psr psr = s1c17_cpu.psr;
	s1c17_reti();
	s1c17_cpu.psr = psr;
}
/* int imm5 */
static void s1c17_int_imm5(/*x9_imm5_x2*/) {
	int imm5 = s1c17_cpu.code.x9_imm5_x2.imm5;
	s1c17_int(imm5);
}
/* intl imm5,imm3 */
static void s1c17_intl_imm5_imm3(/*x6_imm3_imm5_x2*/) {
	int imm3 = s1c17_cpu.code.x6_imm3_imm5_x2.imm3;
	int imm5 = s1c17_cpu.code.x6_imm3_imm5_x2.imm5;
	s1c17_int(imm5);
	s1c17_cpu.psr.il = imm3;
}
/* reti(.d) */
static void s1c17_reti(/*x8_d_x7*/) {
	int d = s1c17_cpu.code.x8_d_x7.d;
	int x = s1c17_bcu_read(4, s1c17_cpu.sp);
	s1c17_cpu.sp += 4;
	if(d) {
		s1c17_cpu_exec();
	}
	s1c17_cpu.pc = (unsigned)(x << 8) >> 8;
	s1c17_cpu.pc &= ~1;
	*(unsigned char*)&s1c17_cpu.psr = x >> 24;
}
/* brk */
static void s1c17_brk(/*x16*/) {
	int dbram = s1c17_bcu_read(4, 0xFFFF90/*DBRAM*/);
	s1c17_bcu_write(4, dbram + 0, s1c17_cpu.pc | (*(unsigned char*)&s1c17_cpu.psr << 24));
	s1c17_bcu_write(4, dbram + 4, s1c17_cpu.r[0]);
	s1c17_cpu.pc = (s1c17_bcu_read(2, 0x5326/*MISC_IRAMSZ*/) & 0x100/*DBADR*/) ? 0x0 : 0xFFFC00;
	s1c17_cpu.psr.ie = 0;
}
/* retd */
static void s1c17_retd(/*x16*/) {
	int dbram = s1c17_bcu_read(4, 0xFFFF90/*DBRAM*/);
	int x = s1c17_bcu_read(4, dbram + 0);
	s1c17_cpu.pc = (unsigned)(x << 8) >> 8;
	s1c17_cpu.pc &= ~1;
	*(unsigned char*)&s1c17_cpu.psr = x >> 24;
	s1c17_cpu.r[0] = s1c17_bcu_read(4, dbram + 4);
	s1c17_cpu.r[0] = (unsigned)(s1c17_cpu.r[0] << 8) >> 8;
}
/* ext imm13 */
static void s1c17_ext_imm13(/*x3_imm13*/) {
	s1c17_cpu.ext2 = s1c17_cpu.ext1;
	s1c17_cpu.ext1 = s1c17_cpu.code.x16;
}
/* sr %rd,%rs */
static void s1c17_sr_rd_rs(/*x6_rd_x4_rs*/) {
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	s1c17_cpu.r[rd] = s1c17_sr(s1c17_cpu.r[rd], s1c17_cpu.r[rs]);
}
/* sr %rd,imm7 */
static void s1c17_sr_rd_imm7(/*x6_rd_imm7*/) { //s1c17_imm7_imm20_imm24
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = s1c17_sr(s1c17_cpu.r[rd], s1c17_imm7_imm20_imm24());
}
/* sa %rd,%rs */
static void s1c17_sa_rd_rs(/*x6_rd_x4_rs*/) {
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	s1c17_cpu.r[rd] = s1c17_sa(s1c17_cpu.r[rd], s1c17_cpu.r[rs]);
}
/* sa %rd,imm7 */
static void s1c17_sa_rd_imm7(/*x6_rd_imm7*/) { //s1c17_imm7_imm20_imm24
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = s1c17_sa(s1c17_cpu.r[rd], s1c17_imm7_imm20_imm24());
}
/* sl %rd,%rs */
static void s1c17_sl_rd_rs(/*x6_rd_x4_rs*/) {
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	s1c17_cpu.r[rd] = s1c17_sl(s1c17_cpu.r[rd], s1c17_cpu.r[rs]);
}
/* sl %rd,imm7 */
static void s1c17_sl_rd_imm7(/*x6_rd_imm7*/) { //s1c17_imm7_imm20_imm24
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = s1c17_sl(s1c17_cpu.r[rd], s1c17_imm7_imm20_imm24());
}
/* swap %rd,%rs */
static void s1c17_swap_rd_rs(/*x6_rd_x4_rs*/) {
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	s1c17_cpu.r[rd] = (((unsigned char*)&s1c17_cpu.r[rs])[0] << 8) | (((unsigned char*)&s1c17_cpu.r[rs])[1] >> 8);
}
/* cv.ab %rd,%rs */
static void s1c17_cv_ab_rd_rs(/*x6_rd_x4_rs*/) {
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	s1c17_cpu.r[rd] = (char)s1c17_cpu.r[rs];
}
/* cv.as %rd,%rs */
static void s1c17_cv_as_rd_rs(/*x6_rd_x4_rs*/) {
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	s1c17_cpu.r[rd] = (short)s1c17_cpu.r[rs];
}
/* cv.al %rd,%rs */
static void s1c17_cv_al_rd_rs(/*x6_rd_x4_rs*/) {
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	s1c17_cpu.r[rd] = (unsigned short)s1c17_cpu.r[rd] | (s1c17_cpu.r[rs] << 16);
}
/* cv.la %rd,%rs */
static void s1c17_cv_la_rd_rs(/*x6_rd_x4_rs*/) {
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	s1c17_cpu.r[rd] = s1c17_cpu.r[rs] >> 16;
}
/* cv.ls %rd,%rs */
static void s1c17_cv_ls_rd_rs(/*x6_rd_x4_rs*/) {
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	s1c17_cpu.r[rd] = (unsigned)(short)s1c17_cpu.r[rs] >> 16;
}
/* nop */
static void s1c17_nop(/*x16*/) {
	/** no job **/
}
/* halt */
static void s1c17_halt(/*x16*/) {
	if(!s1c17_mode) { /* fobO[h̑Jڂh~ */
		s1c17_mode = S1C17_MODE_HALT;
	}
}
/* slp */
static void s1c17_slp(/*x16*/) {
	if(!s1c17_mode) { /* fobO[h̑Jڂh~ */
		s1c17_mode = S1C17_MODE_SLEEP;
	}
}
/* ei */
static void s1c17_ei(/*x16*/) {
	s1c17_cpu.psr.ie = 1;
}
/* di */
static void s1c17_di(/*x16*/) {
	s1c17_cpu.psr.ie = 0;
}
/* ld.cw %rd,%rs */
static void s1c17_ld_cw_rd_rs(/*x6_rd_x4_rs*/) {
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	s1c17_ld_cw(s1c17_cpu.r[rd], s1c17_cpu.r[rs]);
}
/* ld.cw %rd,imm7 */
static void s1c17_ld_cw_rd_imm7(/*x6_rd_imm7*/) { //s1c17_imm7_imm20_imm24
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_ld_cw(s1c17_cpu.r[rd], s1c17_imm7_imm20_imm24());
}
/* ld.ca %rd,%rs */
static void s1c17_ld_ca_rd_rs(/*x6_rd_x4_rs*/) {
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	s1c17_cpu.r[rd] = s1c17_ld_ca(s1c17_cpu.r[rd], s1c17_cpu.r[rs]);
}
/* ld.ca %rd,imm7 */
static void s1c17_ld_ca_rd_imm7(/*x6_rd_imm7*/) { //s1c17_imm7_imm20_imm24
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_cpu.r[rd] = s1c17_ld_ca(s1c17_cpu.r[rd], s1c17_imm7_imm20_imm24());
}
/* ld.cf %rd,%rs */
static void s1c17_ld_cf_rd_rs(/*x6_rd_x4_rs*/) {
	int rd = s1c17_cpu.code.x6_rd_x4_rs.rd;
	int rs = s1c17_cpu.code.x6_rd_x4_rs.rs;
	s1c17_ld_cf(s1c17_cpu.r[rd], s1c17_cpu.r[rs]);
}
/* ld.cf %rd,imm7 */
static void s1c17_ld_cf_rd_imm7(/*x6_rd_imm7*/) { //s1c17_imm7_imm20_imm24
	int rd = s1c17_cpu.code.x6_rd_imm7.rd;
	s1c17_ld_cf(s1c17_cpu.r[rd], s1c17_imm7_imm20_imm24());
}

/****************************************************************************
 *	RAM (foCXTCY = 32rbg)
 ****************************************************************************/

typedef struct _S1C17_IRAM {
	unsigned char m[0x3000];	/* 12KoCg */
} S1C17_IRAM;
static S1C17_IRAM s1c17_iram;

/*--------------------------------------------------------------------------*/

static void s1c17_iram_init() {
	memset(&s1c17_iram, 0, sizeof s1c17_iram);
}
static int s1c17_iram_read(int size, int ofs) {
	int data = 0;
	memcpy(&data, &s1c17_iram.m[ofs], size);
	return data;
}
static void s1c17_iram_write(int size, int ofs, int data) {
	memcpy(&s1c17_iram.m[ofs], &data, size);
}

/****************************************************************************
 *	16rbg^C} (foCXTCY = 16rbg)
 ****************************************************************************/

typedef struct _S1C17_T16 {
	struct {
		struct {
			unsigned short df    : 4;
			unsigned short       :12;
		} clk;			/*0x42x0(T16_CLKx)*/
		unsigned short tr;	/*0x42x2(T16_TRx)*/
		unsigned short tc;	/*0x42x4(T16_TCx)*/
		struct {
			unsigned short prun  : 1;
			unsigned short preser: 1;
			unsigned short       : 2;
			unsigned short trmd  : 1;
			unsigned short       : 3;
			unsigned short cksl  : 2;
			unsigned short ckactv: 1;
			unsigned short       : 5;
		} ctl;			/*0x42x6(T16_CTLx)*/
		struct {
			unsigned short t16if : 1;
			unsigned short       : 7;
			unsigned short t16ie : 1;
			unsigned short       : 7;
		} Int;			/*0x42x8(T16_INTx)*/
	} t16[3];
} S1C17_T16;
static S1C17_T16 s1c17_t16;

/*--------------------------------------------------------------------------*/

static void s1c17_t16_init() {
	static const unsigned char init[] = {
		0x00,0x00,	/*0x42x0(T16_CLKx)*/
		0x00,0x00,	/*0x42x2(T16_TRx)*/
		0xFF,0xFF,	/*0x42x4(T16_TCx)*/
		0x00,0x04,	/*0x42x6(T16_CTLx)*/
		0x00,0x00,	/*0x42x8(T16_INTx)*/
	};
	if(sizeof s1c17_t16.t16[0] != sizeof init) {
		DIE();
	}
	memset(&s1c17_t16, 0, sizeof s1c17_t16);
	memcpy(&s1c17_t16.t16[0], init, sizeof init);
	memcpy(&s1c17_t16.t16[1], init, sizeof init);
	memcpy(&s1c17_t16.t16[2], init, sizeof init);
}
static int s1c17_t16_read(int size, int ofs, int ch) {
	int data = 0;
	if(ofs < sizeof s1c17_t16.t16[0]) {
//		switch(ofs & ~1) {
//		case 0x00:/*0x42x0(T16_CLKx)*/
//		case 0x02:/*0x42x2(T16_TRx)*/
//		case 0x04:/*0x42x4(T16_TCx)*/
//		case 0x06:/*0x42x6(T16_CTLx)*/
//		case 0x08:/*0x42x8(T16_INTx)*/
//		}
		memcpy(&data, &((unsigned char*)&s1c17_t16.t16[ch])[ofs], size);
	}
	return data;
}
static int s1c17_t16_0_read(int size, int ofs) {
	return s1c17_t16_read(size, ofs, 0);
}
static int s1c17_t16_1_read(int size, int ofs) {
	return s1c17_t16_read(size, ofs, 1);
}
static int s1c17_t16_2_read(int size, int ofs) {
	return s1c17_t16_read(size, ofs, 2);
}
static void s1c17_t16_write(int size, int ofs, int data, int ch) {
	if(ofs < sizeof s1c17_t16.t16) {
		if(ofs == 0x08/*0x42x8(T16_INTx)*/) {
			if(data & 1/*T16IF*/) {
				s1c17_t16.t16[ch].Int.t16if = 0; /* Reset by writing 1 */
				data &= ~1/*T16IF*/;
			}
		}
		memcpy(&((unsigned char*)&s1c17_t16.t16[ch])[ofs], &data, size);
		switch(ofs & ~1) {
//		case 0x00:/*0x42x0(T16_CLKx)*/
//		case 0x02:/*0x42x2(T16_TRx)*/
//		case 0x04:/*0x42x4(T16_TCx)*/
		case 0x06:/*0x42x6(T16_CTLx)*/
			if(s1c17_t16.t16[ch].ctl.preser) {
				s1c17_t16.t16[ch].tc = s1c17_t16.t16[ch].tr;
				s1c17_t16.t16[ch].ctl.preser = 0; /* 0 when being read */
			}
			break;
//		case 0x08:/*0x42x8(T16_INTx)*/
		}
	}
}
static void s1c17_t16_0_write(int size, int ofs, int data) {
	s1c17_t16_write(size, ofs, data, 0);
}
static void s1c17_t16_1_write(int size, int ofs, int data) {
	s1c17_t16_write(size, ofs, data, 1);
}
static void s1c17_t16_2_write(int size, int ofs, int data) {
	s1c17_t16_write(size, ofs, data, 2);
}
static void s1c17_t16_exec() { /* 16384TCNs */
	int ch;
	for(ch = 0; ch < 3; ch++) {
		if(s1c17_t16.t16[ch].ctl.prun) {
			int x = 16384 >> s1c17_t16.t16[ch].clk.df;
			if(s1c17_t16.t16[ch].tc >= x) {
				s1c17_t16.t16[ch].tc -= x;
			} else {
				if(s1c17_t16.t16[ch].ctl.trmd) { /* One shot */
					s1c17_t16.t16[ch].tc = s1c17_t16.t16[ch].tr; /* One shot̏ꍇvZbgB(S1C17702eNjJ}jAu11.3 JEg[hvQ) */
					s1c17_t16.t16[ch].ctl.prun = 0;
				} else { /* Repeat */
					do {
						x -= s1c17_t16.t16[ch].tc + 1;
						s1c17_t16.t16[ch].tc = s1c17_t16.t16[ch].tr;
					} while(s1c17_t16.t16[ch].tc < x); /* 16384TCNɕA_[t[ꍇ̂߂ɌJԂB܂Ƃ߂Ĉ̊荞݂ƂĈ */
					s1c17_t16.t16[ch].tc -= x;
				}
				if(s1c17_t16.t16[ch].Int.t16ie) {
					s1c17_t16.t16[ch].Int.t16if = 1;
				}
			}
		}
		if(s1c17_t16.t16[ch].Int.t16if) {
			s1c17_itc_irq(13 + ch);
		}
	}
}

/****************************************************************************
 *	荞݃Rg[ (foCXTCY = 16rbg)
 ****************************************************************************/

typedef struct _S1C17_ITC {
	struct {
		unsigned short lv0;	/*0x4306(ITC_LV0)*/
		unsigned short lv1;	/*0x4308(ITC_LV1)*/
		unsigned short lv2;	/*0x430A(ITC_LV2)*/
		unsigned short lv3;	/*0x430C(ITC_LV3)*/
		unsigned short lv4;	/*0x430E(ITC_LV4)*/
		unsigned short lv5;	/*0x4310(ITC_LV5)*/
		unsigned short lv6;	/*0x4312(ITC_LV6)*/
		unsigned short lv7;	/*0x4314(ITC_LV7)*/
		unsigned short lv8;	/*0x4316(ITC_LV8)*/
	} itc;
} S1C17_ITC;
static S1C17_ITC s1c17_itc;

/*--------------------------------------------------------------------------*/

static void s1c17_itc_init() {
	static const unsigned char init[] = {
		0x00,0x00,	/*0x4306(ITC_LV0)*/
		0x00,0x00,	/*0x4308(ITC_LV1)*/
		0x00,0x00,	/*0x430A(ITC_LV2)*/
		0x00,0x00,	/*0x430C(ITC_LV3)*/
		0x00,0x00,	/*0x430E(ITC_LV4)*/
		0x00,0x00,	/*0x4310(ITC_LV5)*/
		0x00,0x00,	/*0x4312(ITC_LV6)*/
		0x00,0x00,	/*0x4314(ITC_LV7)*/
		0x00,0x00,	/*0x4316(ITC_LV8)*/
	};
	if(sizeof s1c17_itc.itc != sizeof init) {
		DIE();
	}
	memset(&s1c17_itc, 0, sizeof s1c17_itc);
	memcpy(&s1c17_itc.itc, init, sizeof init);
}
static int s1c17_itc_read(int size, int ofs) {
	int data = 0;
	ofs -= 0x06;/*0x4306(ITC_LV0)*/
	if((unsigned)ofs < sizeof s1c17_itc.itc) {
		memcpy(&data, &((unsigned char*)&s1c17_itc.itc)[ofs], size);
	}
	return data;
}
static void s1c17_itc_write(int size, int ofs, int data) {
	ofs -= 0x06;/*0x4306(ITC_LV0)*/
	if((unsigned)ofs < sizeof s1c17_itc.itc) {
		memcpy(&((unsigned char*)&s1c17_itc.itc)[ofs], &data, size);
	}
}
static void s1c17_itc_irq(int no) {
	if(s1c17_mode != S1C17_MODE_DEBUG) { /* fobO[h́An[hEFA荞݁ANMI󂯕tȂ */
		int lv = s1c17_cpu.psr.il; /* NMIꍇ̂߂ɁAl݂̊荞݃xƂĂ */
		if(no >= 4) { /* }XN\荞 */
			if(no <= 21) { /* n[hEFA荞 */
				lv = ((unsigned char*)&s1c17_itc.itc)[no - 4] & 7;
				/* ̃n[hEFA荞݂󂯕t邩ǂɊ֌WAHALTASLEEP[h */
				s1c17_mode = 0;
			}
			if(!s1c17_cpu.psr.ie || (lv <= s1c17_cpu.psr.il)) {
				return; /* ܂ */
			}
		}
		s1c17_int(no);
		s1c17_cpu.psr.il = lv; /* 󂯕t荞݂̃xɃZbg(NMI͊荞݃xύXȂ) */
	}
}

/****************************************************************************
 *	P|[g (foCXTCY = 8rbg)
 ****************************************************************************/

typedef struct _S1C17_P {
	struct {
		unsigned char in;	/*0x52x0(Px_IN)*/
		unsigned char out;	/*0x52x1(Px_OUT)*/
		unsigned char oen;	/*0x52x2(Px_OEN)*/
		unsigned char pu;	/*0x52x3(Px_PU)*/
		unsigned char sm;	/*0x52x4(Px_SM)*/
		unsigned char imsk;	/*0x52x5(Px_IMSK)*/
		unsigned char edge;	/*0x52x6(Px_EDGE)*/
		unsigned char iflg;	/*0x52x7(Px_IFLG)*/
		unsigned char chat;	/*0x52x8(Px_CHAT)*/
		unsigned char krst;	/*0x52x9(Px_KRST)*/
		unsigned char ien;	/*0x52xA(Px_IEN)*/
	} p[3];
} S1C17_P;
static S1C17_P s1c17_p;

/*--------------------------------------------------------------------------*/

static void s1c17_p_init() {
	static const unsigned char init[] = {
		0xFF,	/*0x52x0(Px_IN)*/
		0x00,	/*0x52x1(Px_OUT)*/
		0x00,	/*0x52x2(Px_OEN)*/
		0xFF,	/*0x52x3(Px_PU)*/
		0xFF,	/*0x52x4(Px_SM)*/
		0x00,	/*0x52x5(Px_IMSK)*/
		0x00,	/*0x52x6(Px_EDGE)*/
		0x00,	/*0x52x7(Px_IFLG)*/
		0x00,	/*0x52x8(Px_CHAT)*/
		0x00,	/*0x52x9(Px_KRST)*/
		0xFF,	/*0x52xA(Px_IEN)*/
	};
	if(sizeof s1c17_p.p[0] != sizeof init) {
		DIE();
	}
	memset(&s1c17_p, 0, sizeof s1c17_p);
	memcpy(&s1c17_p.p[0], init, sizeof init);
	memcpy(&s1c17_p.p[1], init, sizeof init);
	memcpy(&s1c17_p.p[2], init, sizeof init);
	memcpy(&s1c17_p.p[3], init, sizeof init);
}
static int s1c17_p_read(int size, int ofs) {
	int data = 0;
	int port = ofs >> 4;
	ofs &= 0x0F;
	if((port < 4) && (ofs < sizeof s1c17_p.p[0])) {
//		switch(ofs) {
//		case 0x00:/*0x52x0(Px_IN)*/
//		case 0x01:/*0x52x1(Px_OUT)*/
//		case 0x02:/*0x52x2(Px_OEN)*/
//		case 0x03:/*0x52x3(Px_PU)*/
//		case 0x04:/*0x52x4(Px_SM)*/
//		case 0x05:/*0x52x5(Px_IMSK)*/
//		case 0x06:/*0x52x6(Px_EDGE)*/
//		case 0x07:/*0x52x7(Px_IFLG)*/
//		case 0x08:/*0x52x8(Px_CHAT)*/
//		case 0x09:/*0x52x9(Px_KRST)*/
//		case 0x0A:/*0x52xA(Px_IEN)*/
//		}
		data = ((unsigned char*)&s1c17_p.p[port])[ofs];
	}
	return data;
}
static void s1c17_p_write(int size, int ofs, int data) {
	int port = ofs >> 4;
	ofs &= 0x0F;
	if((port < 4) && (ofs < sizeof s1c17_p.p[0])) {
		if(ofs == 0x07/*0x52x7(Px_IFLG)*/) {
			s1c17_p.p[port].iflg &= ~data; /* Reset by writing 1 */
		} else {
			((unsigned char*)&s1c17_p.p[port])[ofs] = data;
		}
//		switch(ofs) {
//		case 0x00:/*0x52x0(Px_IN)*/
//		case 0x01:/*0x52x1(Px_OUT)*/
//		case 0x02:/*0x52x2(Px_OEN)*/
//		case 0x03:/*0x52x3(Px_PU)*/
//		case 0x04:/*0x52x4(Px_SM)*/
//		case 0x05:/*0x52x5(Px_IMSK)*/
//		case 0x06:/*0x52x6(Px_EDGE)*/
//		case 0x07:/*0x52x7(Px_IFLG)*/
//		case 0x08:/*0x52x8(Px_CHAT)*/
//		case 0x09:/*0x52x9(Px_KRST)*/
//		case 0x0A:/*0x52xA(Px_IEN)*/
//		}
	}
}
static void s1c17_p_exec() {
	if(s1c17_p.p[0].iflg) {
		s1c17_itc_irq(4);
	}
	if(s1c17_p.p[1].iflg) {
		s1c17_itc_irq(5);
	}
}

/****************************************************************************
 *	MISCWX^ (foCXTCY = 16rbg)
 ****************************************************************************/

typedef struct _S1C17_MISC {
	struct {
		unsigned short fl;	/*0x5320(MISC_FL)*/
		unsigned short osc1;	/*0x5322(MISC_OSC1)*/
		unsigned short prot;	/*0x5324(MISC_PROT)*/
		unsigned short iramsz;	/*0x5326(MISC_IRAMSZ)*/
		unsigned short ttbrl;	/*0x5328(MISC_TTBRL)*/
		unsigned short ttbrh;	/*0x532A(MISC_TTBRH)*/
		unsigned short psr;	/*0x532C(MISC_PSR)*/
	} misc;
} S1C17_MISC;
static S1C17_MISC s1c17_misc;

/*--------------------------------------------------------------------------*/

static void s1c17_misc_init() {
	static const unsigned char init[] = {
		0x03,0x03,	/*0x5320(MISC_FL)*/
		0x00,0x00,	/*0x5322(MISC_OSC1)*/
		0x00,0x00,	/*0x5324(MISC_PROT)*/
		0x00,0x00,	/*0x5326(MISC_IRAMSZ)*/
		0x00,0x80,	/*0x5328(MISC_TTBRL)*/
		0x00,0x00,	/*0x532A(MISC_TTBRH)*/
		0x00,0x00,	/*0x532C(MISC_PSR)*/
	};
	if(sizeof s1c17_misc.misc != sizeof init) {
		DIE();
	}
	memset(&s1c17_misc, 0, sizeof s1c17_misc);
	memcpy(&s1c17_misc.misc, init, sizeof init);
}
static int s1c17_misc_read(int size, int ofs) {
	int data = 0;
	if(ofs < sizeof s1c17_misc.misc) {
		switch(ofs & ~1) {
//		case 0x00:/*0x5320(MISC_FL)*/
//		case 0x02:/*0x5322(MISC_OSC1)*/
//		case 0x04:/*0x5324(MISC_PROT)*/
//		case 0x06:/*0x5326(MISC_IRAMSZ)*/
//		case 0x08:/*0x5328(MISC_TTBRL)*/
//		case 0x0A:/*0x532A(MISC_TTBRH)*/
		case 0x0C:/*0x532C(MISC_PSR)*/
			s1c17_misc.misc.psr = *(unsigned char*)&s1c17_cpu.psr;
			break;
		}
		memcpy(&data, &((unsigned char*)&s1c17_misc.misc)[ofs], size);
	}
	return data;
}
static void s1c17_misc_write(int size, int ofs, int data) {
	if(ofs < sizeof s1c17_misc.misc) {
		memcpy(&((unsigned char*)&s1c17_misc.misc)[ofs], &data, size);
//		switch(ofs & ~1) {
//		case 0x00:/*0x5320(MISC_FL)*/
//		case 0x02:/*0x5322(MISC_OSC1)*/
//		case 0x04:/*0x5324(MISC_PROT)*/
//		case 0x06:/*0x5326(MISC_IRAMSZ)*/
//		case 0x08:/*0x5328(MISC_TTBRL)*/
//		case 0x0A:/*0x532A(MISC_TTBRH)*/
//		case 0x0C:/*0x532C(MISC_PSR)*/
//		}
	}
}

/****************************************************************************
 *	Flash (foCXTCY = 16rbg)
 ****************************************************************************/

typedef struct _S1C17_FLASH {
	unsigned char m[0x20000];	/* 128KoCg */
} S1C17_FLASH;
static S1C17_FLASH s1c17_flash;

/*--------------------------------------------------------------------------*/

static void s1c17_flash_init() {
	/* TODO:tbṼV[PX̂ݏBtbV̓e̓ZbgOɃ[hĂ̂ŁANA */
}
static int s1c17_flash_read(int size, int ofs) {
	int data = 0;
	memcpy(&data, &s1c17_flash.m[ofs], size);
	return data;
}
static void s1c17_flash_write(int size, int ofs, int data) {
	/* TODO:tbṼV[PXɑΉ */
}

/****************************************************************************
 *	\RAM (foCXTCY = 8rbg)
 ****************************************************************************/

typedef struct _S1C17_SRAM {
	unsigned char m[6][0x60];	/* 576oCg */
} S1C17_SRAM;
static S1C17_SRAM s1c17_sram;

/*--------------------------------------------------------------------------*/

static void s1c17_sram_init() {
	memset(&s1c17_sram, 0, sizeof s1c17_sram);
}
static int s1c17_sram_read(int size, int ofs) {
	int data = 0;
	if((unsigned char)ofs < 0x60) {
		data = s1c17_sram.m[ofs >> 8][(unsigned char)ofs];
	}
	return data;
}
static void s1c17_sram_write(int size, int ofs, int data) {
	if((unsigned char)ofs < 0x60) {
		s1c17_sram.m[ofs >> 8][(unsigned char)ofs] = data;
	}
}

/****************************************************************************
 *	I`bvfobK
 ****************************************************************************/

typedef struct _S1C17_DBG {
	struct {
		int ttbr;			/*0xFFFF80(TTBR)*/
		unsigned char idir;		/*0xFFFF84(IDIR)*/
		unsigned char reserved1[11];
		int dbram;			/*0xFFFF90(DBRAM)*/
		unsigned char reserved2[12];
		struct {
			unsigned char dm  : 1;	/* Debug Mode Bit */
			unsigned char se  : 1;	/* Single Step Enable Bit */
			unsigned char ibe0: 1;	/* Instruction Break #0 Enable Bit */
			unsigned char ibe1: 1;	/* Instruction Break #1 Enable Bit */
			unsigned char dr  : 1;	/* Debug Request Flag */
			unsigned char ibe2: 1;	/* Instruction Break #2 Enable Bit */
			unsigned char ibe3: 1;	/* Instruction Break #3 Enable Bit */
			unsigned char ibe4: 1;	/* Instruction Break #4 Enable Bit */
		} dcr;				/*0xFFFFA0(DCR)*/
		unsigned char reserved3[15];
		int IBAR0;			/*0xFFFFB0(IBAR0)*/
		int IBAR1;			/*0xFFFFB4(IBAR1)*/
		int IBAR2;			/*0xFFFFB8(IBAR2)*/
		int IBAR3;			/*0xFFFFBC(IBAR3)*/
		unsigned char ssr;		/*0xFFFFC0(SSR)*/
		unsigned char reserved4[1];
		unsigned char sdr;		/*0xFFFFC2(SDR)*/
		unsigned char reserved5[13];
		int IBAR4;			/*0xFFFFD0(IBAR4)*/
	} dbg;
} S1C17_DBG;
static S1C17_DBG s1c17_dbg;

/*--------------------------------------------------------------------------*/

static void s1c17_dbg_init() {
	static const unsigned char init[] = {
		0x00,0x80,0x00,0x00,	/*0xFFFF80(TTBR)*/
		0x10,			/*0xFFFF84(IDIR)*/
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0xC0,0x2F,0x00,0x00,	/*0xFFFF90(DBRAM)*/
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,			/*0xFFFFA0(DCR)*/
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,	/*0xFFFFB0(IBAR0)*/
		0x00,0x00,0x00,0x00,	/*0xFFFFB4(IBAR1)*/
		0x00,0x00,0x00,0x00,	/*0xFFFFB8(IBAR2)*/
		0x00,0x00,0x00,0x00,	/*0xFFFFBC(IBAR3)*/
		0x06,			/*0xFFFFC0(SSR)*/
		0x00,
		0x00,			/*0xFFFFC2(SDR)*/
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,	/*0xFFFFD0(IBAR4)*/
	};
	if(sizeof s1c17_dbg.dbg != sizeof init) {
		DIE();
	}
	memset(&s1c17_dbg, 0, sizeof s1c17_dbg);
	memcpy(&s1c17_dbg.dbg, init, sizeof init);
}
static int s1c17_dbg_read(int size, int ofs) {
	int data = 0;
	if(ofs < sizeof s1c17_dbg.dbg) {
		switch(ofs & ~3) {
		case 0x00:/*0xFFFF80(TTBR)*/
			s1c17_dbg.dbg.ttbr = s1c17_bcu_read(size, 0x5328/*dbg_TTBRL,dbg_TTBRH*/ + (ofs & 3));
			break;
//		case 0x04:/*0xFFFF84(IDIR)*/
//		case 0x10:/*0xFFFF90(DBRAM)*/
		case 0x20:/*0xFFFFA0(DCR)*/
			s1c17_dbg.dbg.dcr.dm = (s1c17_mode == S1C17_MODE_DEBUG);
			break;
//		case 0x30:/*0xFFFFB0(IBAR0)*/
//		case 0x34:/*0xFFFFB4(IBAR1)*/
//		case 0x38:/*0xFFFFB8(IBAR2)*/
//		case 0x3C:/*0xFFFFBC(IBAR3)*/
//		case 0x40:/*0xFFFFC0(SSR)*/
//		case 0x42:/*0xFFFFC2(SDR)*/
//		case 0x50:/*0xFFFFD0(IBAR4)*/
		}
		memcpy(&data, &((unsigned char*)&s1c17_dbg.dbg)[ofs], size);
	}
	return data;
}
static void s1c17_dbg_write(int size, int ofs, int data) {
	if(ofs < sizeof s1c17_dbg.dbg) {
		if(ofs == 0x20/*0xFFFFA0(DCR)*/) {
			if(data & 0x10/*DR*/) {
				s1c17_dbg.dbg.dcr.dr = 0; /* Reset by writing 1 */
				data &= ~0x10/*DR*/;
			}
		}
		memcpy(&((unsigned char*)&s1c17_dbg.dbg)[ofs], &data, size);
//		switch(ofs & ~3) {
//		case 0x00:/*0xFFFF80(TTBR)*/
//		case 0x04:/*0xFFFF84(IDIR)*/
//		case 0x10:/*0xFFFF90(DBRAM)*/
//		case 0x20:/*0xFFFFA0(DCR)*/
//		case 0x30:/*0xFFFFB0(IBAR0)*/
//		case 0x34:/*0xFFFFB4(IBAR1)*/
//		case 0x38:/*0xFFFFB8(IBAR2)*/
//		case 0x3C:/*0xFFFFBC(IBAR3)*/
//		case 0x40:/*0xFFFFC0(SSR)*/
//		case 0x42:/*0xFFFFC2(SDR)*/
//		case 0x50:/*0xFFFFD0(IBAR4)*/
//		}
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
s1c17_flash_load(int addr, const void* data, int size)
{
	if((addr < 0x008000) || (addr + size > 0x028000)) {
		DIE();
	}
	memcpy(&s1c17_flash.m[addr - 0x008000], data, size);
}

/*--------------------------------------------------------------------------*/

void
s1c17_init()
{
	s1c17_mode = 0;
	s1c17_cycle = 0;

	s1c17_iram_init();
	s1c17_t16_init();
	s1c17_itc_init();
	s1c17_p_init();
	s1c17_misc_init();
	s1c17_flash_init();
	s1c17_sram_init();
	s1c17_dbg_init();

	s1c17_cpu_init(); /* ɈˑĂ̂ŁAŌɏ */
}

/*--------------------------------------------------------------------------*/

void
s1c17_exec(int cycle)
{
	int i;

#ifdef DEBUG
	for(i = 0; i < 8; i++) {
		if(s1c17_cpu.r[i] & ~0xFFFFFF) DIE();
	}
	if(s1c17_cpu.pc & ~0xFFFFFE) DIE();
	if(s1c17_cpu.sp & ~0xFFFFFC) DIE();
#endif /*DEBUG*/

	/* - 16384TCN̎ӉHsA16384TCNCPUs邱Ƃɂ܂B
	 *   1TCNÂsƁAӉH̎s֐ĂяoI[o[wbh傫邽߂łB(T16)
	 * - 16384TCNƂŔAvXP[NbN̍ő啪ŁA̓sǂ߂łB
	 *   8MHzNbN̏ꍇA1/500bɑA[ZԊuƎv܂B
	 */
	s1c17_cycle += cycle;
	while(s1c17_cycle >= 16384) {
		s1c17_cycle -= 16384;

		s1c17_t16_exec();
		s1c17_p_exec();

		/* 1ߕ2TCNŊTZA16384TCN8192߂s邱Ƃɂ܂B
		 * ȂAext߂̎sԂ͌㑱߂Ɋ܂߁AxXbg̎sԂ͐s߂Ɋ܂߂TZłB
		 * oXEFCgAC^[bNlƁA3TCNȏɌςĂǂm܂B
		 * (S1C17̃C^[bN͕słc)
		 */
		i = 16384 / 2/**/;
		do {
			if(s1c17_mode >= S1C17_MODE_HALT) {
				break;
			}
			s1c17_cpu_exec();
		} while(--i);
	}
}

/*--------------------------------------------------------------------------*/

int
s1c17_port_get(int port)
{
	return s1c17_p.p[port].out;
}

void
s1c17_port_set(int port, int data)
{
	int e = s1c17_p.p[port].in ^ data; /* 1 = オA܂́AGbW */
	s1c17_p.p[port].in = data;
	if(port <= 1) { /* |[g荞݋@\Ă̂P0P1̂ */
		int e0 = e &  data; /* 1 = オGbW */
		int e1 = e & ~data; /* 1 = GbW */
		e0 &= ~s1c17_p.p[port].edge; /* 1 = オGbWAAオGbWIĂ */
		e1 &=  s1c17_p.p[port].edge; /* 1 = GbWAAGbWIĂ */
		e = (e0 | e1) & s1c17_p.p[port].imsk; /* 1 = |[g荞ݔ */
		s1c17_p.p[port].iflg |= e; /* 1 = 荞ݗv */
	}
}

/*--------------------------------------------------------------------------*/

/* PIECE_BMP`(1bit)LCD摜擾B
 * 1C4oCgPʂɃpfBO΁AWindows BMP`(1bit)ƂĂg܂B
 */
int s1c17_lcd_image(unsigned char buff[/*32*/][72 / 8]) {
	unsigned char* src = &s1c17_sram.m[0][0];
	unsigned char* dst = &buff[0][0];
	int y = 32 / 8; /* \̈32C8CÂ */
	do {
		int x = 72 / 8; /* \̈72sNZ8sNZÂ */
		do {
			int a[8];
			int i;
			for(i = 0; i < 8; i++) { /* 8C~8sNZ̃f[^擾 */
				a[i] = *src++;
			}
			for(i = 0; i < 8; i++) { /* CƃsNZ̕тւ */
				int b = 0; /* x} */
				int j;
				for(j = 0; j < 8; j++) {
					b <<= 1;
					b |= a[j] & 1;
					a[j] >>= 1;
				}
				*dst = b;
				dst += 72 / 8; /* 1C */
			}
			dst -= 72 - (8 / 8); /* 8ĆA8sNZE */
		} while(--x);
		dst += 72 - (72 / 8); /* 8ĆA72sNZ */
		src += 96 - 72; /* gp̈ */
	} while(--y);
	return 0; /* TODO:LCD̔]rbgɂāADRW_REVX,DRW_REVYԂ */
}
