/*	
 *	clipidle.h
 *
 *	AChXbh
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2009 Naoyuki Sawa
 *
 *	* Fri Jun 19 01:44:03 JST 2009 Naoyuki Sawa
 *	- 1st [XB
 *	* Sun Oct 11 21:57:48 JST 2009 Naoyuki Sawa
 *	- idle_stat()֐ǉ܂B
 *	* Mon Oct 12 05:55:33 JST 2009 Naoyuki Sawa
 *	- idle_exit()֐ǉ܂B
 */
#ifndef __CLIP_IDLE_H__
#define __CLIP_IDLE_H__

/*****************************************************************************
 *	O[o֐
 *****************************************************************************/

/* ACh֐o^܂B
 * [in]
 *	fn		ACh֐BNULLw肷ƁAAChs܂B
 *	param		ACh֐ւ́ACӂ̃p[^B
 * [note]
 *	- {֐́AACh֐o^邾ŁA܂AACh֐N܂B
 *	  ۂɋN̂́Aidle_yield()A܂́Aidle_wait()Ă񂾂ƂłB
 *	- ɃACh֐NĂāArłꍇɁA{֐ĂяoƁA
 *	  r̃ACh֐́AI܂B
 *	  ACh֐AAg~bNłȂĂrɃvGvgA
 *	  CXbhɖ߂A{֐ŋIƁAsȏԂɂȂA
 *	  \[X[N\̂ŁAӂĂB
 * [gp]
 *	- [U[Ƀ[hԂӎȂ悤A^Cgʂ̗Ń[h∳kWJsłB
 *
 *		void schedule() {
 *			...
 *			idle_yield(); // ʏyield()̑ɁAidle_yield()g
 *			...
 *		}
 *
 *		int load_data(int param) {
 *			... // ԂA[hAkWJȂǁBvGvĝŗv!
 *			return exit_code;
 *		}
 *
 *		void app_main() {
 *			idle_init(load_data, data_number); // ^Cgʂ̗ŁA[hs悤o^
 *			for(;;) {
 *				schedule();
 *				... // ^Cgʏ
 *			}
 *			exit_code = idle_wait(); // [hf[^gOɁAmɃ[h
 *			for(;;) {
 *				schedule();
 *				... // Q[ʏ
 *			}
 *		}
 */
void idle_init(int (*fn)(int param), int param);

/* c^CXCXŃAChsAVXes܂B
 * [note]
 *	- ACh֐o^ĂȂꍇAɏIĂꍇ́A
 *	  AChsɃVXesAc莞Ԃhalt܂B
 *	- ^CXCXcĂȂꍇ́AAChs܂B
 *	  [U[AɃt[Ԃ𒴉߂Ă悤ȃvOł́A
 *	  AChSsȂꍇL蓾̂ŁAӂĂB
 */
void idle_yield();

/* AChׂĎsAIR[hԂ܂B
 * [out]
 *	߂l		ACh֐̖߂lB
 * [note]
 *	- ACh֐ɏIĂꍇ́AɏIR[hԂ܂B
 *	  ACh֐o^ĂȂꍇAɏԂ܂A߂l͖`łB
 *	- ACh֐IȂA[vłꍇ́A{֐Ԃ܂B
 *	  AvP[V́AnOAbvĂ܂̂ŁAӂĂB
 */
int idle_wait();

/* ACh̎sԂ擾܂B
 * [out]
 *	߂l		ACh̎sԁB
 *			ACh֐܂IĂȂꍇ́A0ȊO̒lԂ܂B
 *			ACh֐o^ĂȂꍇAɏIĂꍇ́A0Ԃ܂B
 * [note]
 *	- AvP[VAȉ̗̂悤ɗp邱Ƃz肵āÅ֐pӂ܂B
 *	  AvP[ṼC[vŁAAChI܂ŁAʂ̏sp@łB
 *
 *		void app_main() {
 *			int exit_code;
 *			idle_init(load_data, data_number); // Ԃ̂郍[hAAChŎs
 *			while(idle_stat()) { // AChI܂Łc
 *				schedule() ; // ̒ŁAAChs
 *				// ŁANow Loading...Aj[V\ //
 *			}
 *			//exit_code = idle_wait(); // IR[hKvȂ΁Aidle_wait()Ă΂ȂĂ\܂
 *			for(;;) {
 *				schedule();
 *				// [hf[^gāAC[vs //
 *			}
 *		}
 */
int idle_stat();

/* AChI܂B
 * [in]
 *	exit_code	IR[hB
 * [note]
 *	- ACh֐return̂Ɠʂ܂B
 *	  ACh֐Ăяoꂽ֐̒AځAAChI邽߂ɗpӂ܂B
 *	- {֐́AAChXbh̃ReLXĝ݁AĂяo\łB
 *	  ʏ̃ReLXgĂяoƁAُ퓮ƂȂ܂B
 * [gp]
 *	int idle_proc(int param) { // ACh֐
 *		idle_proc_sub1();
 *	}
 *	void idle_proc_sub1() {
 *		idle_proc_sub2();
 *	}
 *	void idle_proc_sub2() {
 *		idle_exit(123); // exit_code = 123
 *	}
 */
void idle_exit(int exit_code) __attribute__((noreturn));

#endif /*__CLIP_IDLE_H__*/

